

#                                                      _/        Author | Ec|ipse
#      _/_/_/   _/_/_/_/   _/_/_/  _/_/_/  _/ _/_/  _/_/_/_/     E-Mail | tomas@primenet.com
#   _/    _/  _/_/      _/       _/    _/ _/_/   _/  _/         Website | www.primenet.com/~tomas
#  _/    _/       _/_/ _/       _/ _/    _/     _/  _/   _/     Version | 0.4 Beta 2
#   _/_/ _/ _/_/_/_/    _/_/_/   _/_/_/ _/     _/   _/_/_/  _/


# Things to do in future releases
# - Add additional/missing commands (Help routines)
# - Add additional/missing commands (Popups)
# - Need to redo chanmode to accept both keys and limits
# - Need to rewrite/cleanup operkill routines
# - Need to figure out why Closing Link error is present on Quit
# - Move userlist routines to DLL file
# - Finish msg commands for known users
# - Add built in partyline
# - Add server output flood control


set version "Ascent"
set revision "0.4 \002(\002beta 2\002)\002"
set fullversion "\002A\002scent v$revision for X\002i\002RCON [version]"
 
on load {
  if {![connected] && [window_type] == "status"} {
    echo "Loading \002[string tolower $version]\002..." status
    echo "[color highlight]\002ascent\002 (e-snt') n. \0021.\002 the act of rising, mounting or moving upward : to climb. \0022.\002 an upward slope or rising grade. \0023.\002 the act of rising above others." status
    echo " Internal help can be accessed by typeing \002[color ctcp]/ihelp\002[color default] at any time." status
    echo " " status
  } {
    echo "[get_cookie Char]Re-Loading \002[string tolower $version]\002..." status
  }
  set idx [lsearch [scripts] *[string tolower $version].tcl]
  if {$idx == -1} {
    error "Unable to find path for ascent.tcl"
  } {
    regexp -nocase {(.*)\\ascent.tcl$} [lindex [scripts] $idx] a scriptDir
    set_cookie Directory($version) [file dirname $scriptDir/ascent.tcl]
    set_cookie Directory(XiRCON) [file dirname [get_cookie Directory($version)]]
    set_cookie Directory(Logs) [file dirname [get_cookie Directory($version)]]/Logs
    set_cookie Directory(XDCC) [file dirname [get_cookie Directory($version)]]/XDCC
    set_cookie Directory(Journals) [file dirname [get_cookie Directory($version)]]/Journals

# Necessary source files loaded during setup.
    source ${scriptDir}\\aliases.tcl            ;# common aliases
    source ${scriptDir}\\events.tcl             ;# triggered events
    source ${scriptDir}\\helpdoc.tcl            ;# internal help system /ihelp
    source ${scriptDir}\\misc.tcl               ;# miscellaneous procedures
    source ${scriptDir}\\timers.tcl             ;# internal timer system like Eggdrop

# Necessary cookies loaded on install
    if {![llength [get_cookie ${version}(Scripting)]] || ![get_cookie ${version}(Scripting)]} {
      if {![llength [get_cookie Autoaway(Away)]]} {set_cookie AutoAway(Away) 1}
      if {![llength [get_cookie Autoaway(Return)]]} {set_cookie AutoAway(Return) 1}
      if {![llength [get_cookie Away(msg)]]} {set_cookie Away(msg) "none"}
      if {![llength [get_cookie Away(recorder)]]} {set_cookie Away(recorder) "On"}
      if {![llength [get_cookie Away(pager)]]} {set_cookie Away(pager) "Off"}
      if {![llength [get_cookie Away(timezone)]]} {set_cookie Away(timezone) "PST"}
      if {![llength [get_cookie Away(sound)]]} {set_cookie Away(sound) "motorola.wav"}
      if {![llength [get_cookie Away(defAway)]]} {set_cookie Away(defAway) "Away from PC"}
      if {![llength [get_cookie Away(defBack)]]} {set_cookie Away(defBack) "Ok, what'd I miss??"}
      if {![llength [get_cookie Away(Time)]]} {set_cookie Away(Time) [clock seconds]}
      if {![llength [get_cookie Channel(WordKicks)]]} {set_cookie Channel(WordKicks) ""}
      if {![llength [get_cookie Channel(Modes)]]} {set_cookie Channel(Modes) "autojoin autoop autovoice stopnethack protectuser bitch shitlist lockmode locktopic wordcheck nickflood textflood actflood joinflood repeat moderate"}
      if {![llength [get_cookie Channel(Modes-Defaults)]]} {set_cookie Channel(Modes-Defaults) [prompt "Default Channel IRC modes (nstmilk)" "Enter modes to set as default." "nst"]}
      if {![llength [get_cookie Char]]} {set_cookie Char " "}
      if {![llength [get_cookie CTCP-Last(Type)]]} {set_cookie CTCP-Last(Type) ""}
      if {![llength [get_cookie CTCP-Last(From)]]} {set_cookie CTCP-Last(From) ""}
      if {![llength [get_cookie CTCP(Sed)]]} {set_cookie CTCP(Sed) "Get bent."}
      if {![llength [get_cookie CTCP(Version)]]} {set_cookie CTCP(Version) "$fullversion, TCL powered IRC client"}
      if {![llength [get_cookie CTCP(XDCC)]]} {set_cookie CTCP(XDCC) "SEND LIST Use XDCC <COMMAND> to get more specific information"}
      if {![llength [get_cookie CTCP(Clientinfo)]]} {set_cookie CTCP(Clientinfo) "SED VERSION CLIENTINFO USERINFO ERRMSG FINGER TIME ACTION DCC XDCC UTC PING ECHO  :Use CLIENTINFO <COMMAND> to get more specific information"}
      if {![llength [get_cookie CTCP-Clientinfo(sed)]]} {set_cookie CTCP-Clientinfo(sed) "SED contains simple_encrypted_data"}
      if {![llength [get_cookie CTCP-Clientinfo(version)]]} {set_cookie CTCP-Clientinfo(version) "VERSION shows client type, version and environment"}
      if {![llength [get_cookie CTCP-Clientinfo(clientinfo)]]} {set_cookie CTCP-Clientinfo(clientinfo) "CLIENTINFO gives information about available CTCP commands"}
      if {![llength [get_cookie CTCP-Clientinfo(userinfo)]]} {set_cookie CTCP-Clientinfo(userinfo) "USERINFO returns user settable information"}
      if {![llength [get_cookie CTCP-Clientinfo(errmsg)]]} {set_cookie CTCP-Clientinfo(errmsg) "ERRMSG returns error messages"}
      if {![llength [get_cookie CTCP-Clientinfo(finger)]]} {set_cookie CTCP-Clientinfo(finger) "FINGER shows real name, login name and idle time of user"}
      if {![llength [get_cookie CTCP-Clientinfo(time)]]} {set_cookie CTCP-Clientinfo(time) "TIME tells you the time on the user's host"}
      if {![llength [get_cookie CTCP-Clientinfo(action)]]} {set_cookie CTCP-Clientinfo(action) "ACTION contains action descriptions for atmosphere"}
      if {![llength [get_cookie CTCP-Clientinfo(dcc)]]} {set_cookie CTCP-Clientinfo(dcc) "DCC requests a direct_client_connection"}
      if {![llength [get_cookie CTCP-Clientinfo(utc)]]} {set_cookie CTCP-Clientinfo(utc) "UTC substitutes the local timezone"}
      if {![llength [get_cookie CTCP-Clientinfo(ping)]]} {set_cookie CTCP-Clientinfo(ping) "PING returns the arguments it receives"}
      if {![llength [get_cookie CTCP-Clientinfo(echo)]]} {set_cookie CTCP-Clientinfo(echo) "ECHO returns the arguments it receives"}
      if {![llength [get_cookie CTCP-Clientinfo(xdcc)]]} {set_cookie CTCP-Clientinfo(xdcc) "XDCC performs a direct_client_connection for file_transfers"}
      if {![llength [get_cookie DatFile(Servers)]]} {set_cookie DatFile(Servers) serverlist.dat}
      if {![llength [get_cookie DatFile(Lastseen)]]} {set_cookie DatFile(Lastseen) lastseen.dat}
      if {![llength [get_cookie DatFile(Notify)]]} {set_cookie DatFile(Notify) notifylist.dat}
      if {![llength [get_cookie DatFile(UserList)]]} {set_cookie DatFile(UserList) userlist.dat}
      if {![llength [get_cookie Directory(Waves)]]} {set path [prompt "Directory For Wave Files" "Enter path to your wave files" [get_cookie Directory(Waves)]] ; regsub -all {\\} $path {/} path ; set_cookie Directory(Waves) $path}
      if {![llength [get_cookie Directory(URLS)]]} {set path [prompt "Directory For Browser Bookmarks" "Enter path to your browsers bookmarks" [get_cookie Directory(URLS)]] ; regsub -all {\\} $path {/} path ; set_cookie Directory(URLS) $path}
      if {![llength [get_cookie Display(Output)]]} {set display [prompt "Display Window" "Display system messages to Channel (1) or Status (0)" "1"] ; set_cookie Display(Output) $display}
      if {![llength [get_cookie Hilite(Words)]]} {set_cookie Hilite(Words) "[my_nick]"}
      if {![llength [get_cookie Hilite(OwnText)]]} {set_cookie Hilite(OwnText) "1"}
      if {![llength [get_cookie Help(Words)]]} {set_cookie Help(Words) "addhost addshit adduser ame amsg antiidle autojoin away back ban chat chanmode chanrec chanstats chattr chnick clonechk ctcpstats cycle deop describe devoice dns do dv find fk fwall fwo gb gban hilite ignore ignores istats iwhois j join k kb kbi kick kickall kickban kickno kicknv kicko kickv killtimer killutimer leet leetkickban listopers lk lkb lkbi ll longip m mass+o mass+v mass-o mass-v match mi msgs notify o op operkill p part ping privmode quit regain reload remhost remshit remuser save saway scripts seen setup sound splitchk tcl telnet timer timers tkb topic utimer utimers v viewfile viewlog voice w wall whos whosshit wordkick"}
      if {![llength [get_cookie Ignore(Types)]]} {set_cookie Ignore(Types) "All Public CTCP Query"}
      if {![llength [get_cookie Lastseen(Length)]]} {set_cookie Lastseen(Length) 0}
      if {![llength [get_cookie Lastseen(Modifier)]]} {set_cookie Lastseen(Modifier) 1209600}
      if {![llength [get_cookie Lookup(DNS)]]} {set_cookie Lookup(DNS) "none"}
      if {![llength [get_cookie Lookup(LongIP)]]} {set_cookie Lookup(LongIP) 0}
      if {![llength [get_cookie Notify(CurrentList)]]} {set_cookie Notify(CurrentList) [getnotify]}
      if {![llength [get_cookie Notify(Whois)]]} {set_cookie Notify(Whois) 1}
      if {![llength [get_cookie Personal(Modes)]]} {set_cookie Personal(Modes) [prompt "Default Personal IRC modes (iwsk)" "Enter modes to set as default." "iwsk"]}
      if {![llength [get_cookie Userlist(CFlags)]]} {set_cookie Userlist(CFlags) "aopfvbk"}
      if {![llength [get_cookie Userlist(DFlags)]]} {set_cookie Userlist(DFlags) "f"}
      if {![llength [get_cookie Userlist(GFlags)]]} {set_cookie Userlist(GFlags) "aopfvbk"}
      if {![llength [get_cookie RegainNick(Nick)]]} {set_cookie RegainNick(Nick) "[prompt "Nickname you use on IRC" "Enter your favorite nickname" ""]"}
      if {![llength [get_cookie SpecialEventLogs]]} {set_cookie SpecialEventLogs "awaymsg channel personal xdcc"}
      if {![llength [get_cookie Split(Server)]]} {set_cookie Split(Server) ""}
      if {![llength [get_cookie Split(Detector)]]} {set_cookie Split(Detector) 0}
      if {![llength [get_cookie Status]]} {set_cookie Status 0}
      if {![llength [get_cookie System(Paths)]]} {set_cookie System(Paths) "c:/ c:/windows/ c:/windows/system/ [gdx] [gds] [gdl] [gdj]"}
      if {![llength [get_cookie Toggle(AntiIdle)]]} {set_cookie Toggle(AntiIdle) 0}
      if {![llength [get_cookie Toggle(AutoJoin)]]} {set_cookie Toggle(AutoJoin) 0}
      if {![llength [get_cookie Toggle(Hilite)]]} {set_cookie Toggle(Hilite) 0}
      if {![llength [get_cookie Toggle(IAL)]]} {set_cookie Toggle(IAL) "[prompt "Internal Address List settings" "Should IAL to be Passive (0) or Aggressive (1)" "0"]"}
      if {![llength [get_cookie Toggle(Lastseen)]]} {set_cookie Toggle(Lastseen) 0}
      if {![llength [get_cookie Toggle(LinkLooker)]]} {set_cookie Toggle(LinkLooker) 0}
      if {![llength [get_cookie Toggle(links)]]} {set_cookie Toggle(Links) "[prompt "Server Dependant Features" "Run all features seperately per connection \[0/1\]" "1"]"}
      if {![llength [get_cookie Toggle(NickComplete)]]} {set_cookie Toggle(NickComplete) 0}
      if {![llength [get_cookie Toggle(Notify)]]} {set_cookie Toggle(Notify) 0}
      if {![llength [get_cookie Toggle(OperKill)]]} {set_cookie Toggle(OperKill) 0}
      if {![llength [get_cookie Toggle(Operchk)]]} {set_cookie Toggle(Operchk) 0}
      if {![llength [get_cookie Toggle(PersonalLog)]]} {set_cookie Toggle(PersonalLog) 0}
      if {![llength [get_cookie Toggle(RegainNick)]]} {set_cookie Toggle(RegainNick) 0}
      if {![llength [get_cookie Toggle(URL's)]]} {set_cookie Toggle(URL's) 1}
      if {![llength [get_cookie Toggle(Links)]]} {set_cookie Toggle(Links) "[prompt "Update of Servers Links" "Should Autojoin be dependant on servers links \[0/1\]" "1"]"}
      if {![llength [get_cookie Update(LinksList)]]} {set_cookie Update(LinksList) ""}
      if {![llength [get_cookie Update(Links)]]} {set_cookie Update(Links) 1}
      if {![llength [get_cookie XDCC(Offering)]]} {set_cookie XDCC(Offering) 0}
      if {![llength [get_cookie XDCC(Track)]]} {set_cookie XDCC(Track) 0}
      if {[get_cookie Webpage] != "http:\\\\www.primenet.com\\~tomas"} {set_cookie Webpage http:\\\\www.primenet.com\\~tomas}
      if {[get_cookie IRCserver] != ""} {quit [get_cookie IRCserver]}
      if {[file exists [gdj]xdcc.log]} {file rename -force [gdj]xdcc.log [gdj]xdcc.log.previous}
      if {[file exists [gdj]awaymsg.log]} {file rename -force [gdj]awaymsg.log [gdj]awaymsg.log.previous}
      if {[file exists [gdj]channel.log]} {file rename -force [gdj]channel.log [gdj]channel.log.previous}
      if {[file exists [gdj]personal.log]} {file rename -force [gdj]personal.log [gdj]personal.log.previous}
      if {[get_cookie $version] != $revision} {set_cookie $version $revision}
    }

# Check to see if properly loaded
    if {[get_cookie $version] != $revision} {
      echo "[get_cookie Char]You have not read the Readme.txt file..."
      if {[connected]} {/quit You must read the README.txt file...}
      complete
    }

# Necessary files that need to exist
    if {![file exists [gdx][get_cookie DatFile(Lastseen)]]} {makefile [gdx][get_cookie DatFile(Lastseen)]} {openseen}
    if {![file exists [gdx][get_cookie DatFile(Notify)]]} {makefile [gdx][get_cookie DatFile(Notify)]} {opennotify}
    if {![file exists [gdx][get_cookie DatFile(Servers)]]} {makefile [gdx][get_cookie DatFile(Servers)] ; set_cookie Update(ServerList) 1}
    if {![file exists [gdx][get_cookie DatFile(Userlist)]]} {makefile [gdx][get_cookie DatFile(Userlist)]} {getuserfile}

# Necessary settings during loads.
    if {![info exists ashift]} {set ashift "on"}
    if {![info exists ashift_cnt]} {set ashift_cnt 0}
    if {![info exists ashift_max]} {set ashift_max 6}
    if {![info exists ashift_lvl]} {set ashift_lvl "Minor"}
    if {![info exists lastseen]} {set lastseen_length [llength [array names lastseen]] ; set_cookie Lastseen(Length) $lastseen_length}
    if {[get_cookie IRCserver] == "" && [connected]} {set_cookie IRCserver [lindex [server] 0]}
    if {[connected] && ![info exists IRCserver]} {set IRCserver [lindex [server] 0] ; set_cookie Connection($IRCserver) 1 ; online}
    if {[get_cookie Toggle(IAL-[lindex [server] 0])] == 1 && [connected]} {set_cookie Update(IAL-[lindex [server] 0]) 1 ; create_ul} {set_cookie Update(IAL-[lindex [server] 0]) 0}

# Helps Prevent ping-timeouts, uncomment the following line
    antiidle
  }
  complete
}

# Necessary sources loaded outside of "On Load".
source [get_cookie Directory($version)]/popups.tcl   ;# popups for status, channel, users & chat
