on connect {
  display "[get_cookie Char]Connected to [color nick][join [args]]"
  set_cookie Update(Links) 1
  set IRCserver [lindex [server] 0]
  set_cookie Quitting($IRCserver) 0
  set_cookie Connection($IRCserver) 1
  set_cookie LogonTime [clock seconds]
  if {[get_cookie Update(Links)] && [get_cookie Toggle(Links)]} {
    if {[lsearch [get_cookie Update(LinksList)] $IRCserver] != -1} {/utimer 3 autojoin} {
      /raw time [lindex [get_cookie Update(LinksList)] 0]
    }
  } {/utimer 3 autojoin}
  /raw mode [my_nick] +[get_cookie Personal(Modes)]
  if {[get_cookie Toggle(Notify)] == 1 && [connected]} {
    /utimer 60 set_cookie Toggle(Notify-Go) 1
  }
  connect [lindex [server] 0]
  online
}
on disconnect {
  set_cookie Update(IAL-[lindex [server] 0]) ""
  set_cookie Notify(ISON-[lindex [server] 0]) ""
  set_cookie Toggle(Away-[lindex [server] 0]) 0
  if {[info exists IRCserver]} {
    if {[get_cookie Quitting($IRCserver)] == 0 && [get_cookie Connection($IRCserver)] == 1} {
      if {[lsearch [get_cookie Update(LinksList)] $IRCserver] != -1} {
        set sid [expr [random 1 [llength [get_cookie Update(LinksList)]]] - 1]
        if {$sid >= [llength [get_cookie Update(LinksList)]]} {set sid 0}
        set server [lindex [get_cookie Update(LinksList)] $sid]
        incr sid
        after 3000 /raw server $server
      } {
        after 3000 /raw server $IRCserver
      }
    }
  }
  complete
}
on error {
  set_cookie Update(IAL-[lindex [server] 0]) ""
  set_cookie Notify(ISON-[lindex [server] 0]) ""
  if {[info exists IRCserver]} {
    if {[get_cookie Quitting($IRCserver)] == 0 && [get_cookie Connection($IRCserver)] == 1} {
      if {[lsearch [get_cookie Update(LinksList)] $IRCserver] != -1} {
        set sid [expr [random 1 [llength [get_cookie Update(LinksList)]]] - 1]
        if {$sid >= [llength [get_cookie Update(LinksList)]]} {set sid 0}
        set server [lindex [get_cookie Update(LinksList)] $sid]
        incr sid
        after 3000 /raw server $server
      } {
        after 3000 /raw server $IRCserver
      }
    }
  }
}
on invite {
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  if {[matchignore All $addresslist([string tolower $nick])] || \
      [matchignore Invite $addresslist([string tolower $nick])]} {
    complete ; return
  }
  set_cookie Invite(Channel) [string range [lindex [raw_args] 1] 1 end]
  display "[get_cookie Char](\002Invite\002) [color nick][nick][color ctcp] invites you to join [color nick][lindex [args] 1]"
  display "  Press '[color nick]<ctrl> j[color default]' to join [color nick][lindex [args] 1]"
  logevent personal "[nick] ([user]@[host]) Invited you to [lindex [args] 1]"
  complete
}
on join {
  global version
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  set id [chanid [lindex [args] 0]]
  echo "[get_cookie Char](\002Join\\[lindex [args] 0]\002) [color nick]$nick [color join]($user@$host)" channel [lindex [args] 0]
  if {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[string first autoop [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && [matchattr [nick2hand [nick] [lindex [args] 0]] a] || [matchattr [nick2hand [nick] [lindex [args] 0]] a [lindex [args] 0]]} {
        display "[get_cookie Char]Auto-oping [color nick][nick][color default] (valid) on [color nick][lindex [args] 0]"
        /raw mode [nick] +o [lindex [args] 0]
      }
    } elseif {[string first shitlist [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && [matchattr [nick2hand [nick] [lindex [args] 0]] b] || [matchattr [nick2hand [nick] [lindex [args] 0]] b [lindex [args] 0]]} {
        display "[get_cookie Char]Shitlisted user [color nick][nick][color default] (valid) on [color nick][lindex [args] 0]"
        /raw mode [lindex [args] 0] +b [getmask [nick]![user]@[host] 3]
        /raw kick [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
        logevent channel "[nick] ([user]@[host]) (shitlisted) Joined [lindex [args] 0]"
      } elseif {[nick] != [my_nick] && [matchattr [nick2hand [nick] [lindex [args] 0]] k] || [matchattr [nick2hand [nick] [lindex [args] 0]] k [lindex [args] 0]]} {
        display "[get_cookie Char]Shitlisted user [color nick][nick][color default] (valid) on [color nick][lindex [args] 0]"
        /ban -u3 [getmask [nick]![user]@[host] 3]
        /raw kick [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
        logevent channel "[nick] ([user]@[host]) (shitlisted) Joined [lindex [args] 0]"
      }
    }
  }
  if {[nick] == [my_nick] && [get_cookie Toggle(IAL-[lindex [server] 0])]} {update_ul [lindex [args] 0]}
  lastseen "[nick]" "[nick]![user]@[host]" "[clock seconds]" "join" "[lindex [args] 0]" "-"
  complete
}
on part {
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  echo "[get_cookie Char](\002Part\\[lindex [args] 0]\002) [color nick]$nick [color part]($user@$host)" channel [lindex [args] 0]
  lastseen "[nick]" "[nick]![user]@[host]" "[clock seconds]" "part" "[lindex [args] 0]" "-"
  complete
}
on kick {
  global version
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  set id [chanid [lindex [args] 0]]
  echo "[color part][get_cookie Char][lindex [args] 1] has been kicked from [color nick][lindex [args] 0][color part] by [color nick][nick][color part] ([join [lindex [args] 2]])" channel [lindex [args] 0]
  if {[lindex [args] 1] == [my_nick]} {
    display "[get_cookie Char][color nick][nick] [color ctcp]([user]@[host])[color change] Kicked you on [color nick][lindex [args] 0]"
    logevent personal "[nick] ([user]@[host]) Kicked you on [lindex [args] 0]"
  } elseif {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[string first protect [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && [matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] p] || [matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] p [lindex [args] 0]]} {
        display "[get_cookie Char]Kicked [color nick][nick][color default] kicked [color nick][lindex [args] 1] ([lrange [args] 2 end])[color default] (protected) on [color nick][lindex [args] 0]"
        /raw mode [lindex [args] 0] -o [nick]
        /raw kick [lindex [args] 0] [nick] :\002$version\002: Protected user, donut do that.
        /raw invite [lindex [args] 1] [lindex [args] 0]
        logevent channel "[nick] ([user]@[host]) Kicked [lindex [args] 1] (protected) on [lindex [args] 0]"
      }
    }
  }
  lastseen "[lindex [args] 1]" "-" "[clock seconds]" "kick" "[lindex [args] 0]" "[join [lrange [args] 2 end]]"
  complete
}
on quit {
  global version
  foreach chan [channels] {
    foreach nick [nicks $chan] {
      if {[string trimleft $nick @+] == [nick]} {
        if {[string first irc [string tolower [lrange [raw_args] 0 end]]] != -1 && [string first .*. [string tolower [lrange [raw_args] 0 end]]] != -1} {
          if {![llength [get_cookie ServerSplit]]} {
            display "[get_cookie Char](\002Split\\[lindex [raw_args] 1]\002) [color nick][lindex [raw_args] 1][color ctcp] has split from [color nick][lindex [raw_args] 0]"
            display "  Press '[color nick]<ctrl> j[color default]' to join [color nick][lindex [args] 1]"
            /utimer 60 set_cookie ServerSplit \"\"
            set_cookie ServerSplit 1
          }
          addsplit [nick]
        } {
          echo "[get_cookie Char](\002Quit\\$chan\002) [color quit][nick] ([join [args]])" channel $chan
        }
      }
    }
  }
  if {[get_cookie Split(Detector)] == 1} {
    if {[lindex [raw_args] 0] == [lindex [server] 0]} {
      display "[color highlight][get_cookie Char]$version has detected that you are possibly \002Split\002."
    }
    if {[string first Killed [lindex [raw_args] 0]] != -1 && [string first irc [string tolower [lrange [raw_args] 0 end]]] != -1} {
      display "[color highlight][get_cookie Char]Possible \002rejoin\002 detected on: \002[color nick][string range [lindex [raw_args] 1] 1 end]\002"
      set_cookie Split(Server) [string range [lindex [raw_args] 1] 1 end]
      /utimer 60 set_cookie Split(Server) \"\"
    } {
      if {[string first irc. [string tolower [raw_args]]] != -1 || \
          [string first ircd. [string tolower [raw_args]]] != -1} {
        if {[string first .org [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .net [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .com [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .edu [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .gov [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .fi [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .ca [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .jp [string tolower [lrange [raw_args] 0 end]]] != -1 || \
            [string first .se [string tolower [lrange [raw_args] 0 end]]] != -1} {
          if {![string match [lindex [raw_args] 1] [get_cookie Split(Server)]]} {
            display "[color highlight][get_cookie Char]Possible \002split\002 detected on: \002[color nick][lindex [raw_args] 1]\002"
            set_cookie Split(Server) [lindex [raw_args] 1]
            /utimer 60 set_cookie Split(Server) \"\"
          }
        }
      }
    }
  }
  lastseen "[nick]" "[nick]![user]@[host]" "[clock seconds]" "quit" "-" "[join [args]]"
  complete
}
on nick {
  global version addresslist
  set nick [nick]
  set user [user]
  set host [host]
  set newnick [lindex [args] 0]
  if {[nick] == [my_nick]} {
    foreach chan [channels] {echo "[color change][get_cookie Char][color nick][nick][color change] is now known as [color nick]$newnick" channel $chan}
    if {[channels] == ""} {echo "[color change][get_cookie Char][color nick][nick][color change] is now known as [color nick]$newnick" status}
  } {
    if {[string tolower [nick]] == [string tolower [get_cookie RegainNick(Nick)]]} {
      if {[get_cookie Toggle(RegainNick)] == 1} {/raw nick [get_cookie RegainNick(Nick)]}
    }
    foreach chan [channels] {
      foreach n [nicks $chan] {
        if {[chk4spec [string trimleft $n @+]] == [nick]} {
          echo "[color change][get_cookie Char][color nick][string trimleft $nick @+][color change] is now known as [color nick]$newnick" channel $chan
          if {[info exists addresslist([string tolower [nick]])]} {
            unset addresslist([string tolower [nick]])
            addresslist $newnick $user $host
          } {
            addresslist $newnick $user $host
          }
          set id [chanid [lindex [args] 0]]
          if {$id != -1 && [isop [my_nick] $chan]} {
            if {[string first shitlist [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
              if {[nick] != [my_nick] && [matchattr [nick2hand [nick] $chan] b] || [matchattr [nick2hand [nick] $chan] b $chan]} {
                display "[get_cookie Char]Shitlisted user [color nick]$newnick[color default] (valid) on [color nick]$chan"
                /raw mode $chan +b [getmask [nick]![user]@[host] 3]
                /raw kick $chan [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
                logevent channel "[nick] ([user]@[host]) (shitlisted) Joined [lindex [args] 0]"
              } elseif {[nick] != [my_nick] && [matchattr [nick2hand [nick] $chan] k] || [matchattr [nick2hand [nick] $chan] k $chan]} {
                display "[get_cookie Char]Shitlisted user [color nick][nick][color default] (valid) on [color nick]$chan"
                /ban -u3 [getmask [nick]![user]@[host] 3]
                /raw kick $chan [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
                logevent channel "[nick] ([user]@[host]) (shitlisted) Joined [lindex [args] 0]"
              }
            }
          }
        }
      }
    }
    nickflood_chk [chk4spec [nick]] $newnick $chan
    lastseen "[lindex [args] 0]" "[lindex [args] 0]![user]@[host]" "[clock seconds]" "nick" "-" "[nick]"
  }
  complete
}

on mode+o {
  global version
  set id [chanid [lindex [args] 0]]
  if {[lindex [args] 1] == [my_nick]} {
    display "[get_cookie Char][color nick][nick] [color ctcp]([user]@[host])[color change] Opted you on [color nick][lindex [args] 0]"
    logevent personal "[nick] ([user]@[host]) Opted you on [lindex [args] 0]"
  } elseif {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[string first stopnethack [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![llength [nick]] && ![matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] o] && ![matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] o [lindex [args] 0]]} {
        display "[get_cookie Char](\002Nethack\\[lindex [args] 0]\002) +o [color nick][lindex [args] 1][color default] by [color nick][get_cookie Split(Server)]"
        /raw mode [lindex [args] 0] -o [lindex [args] 1]
        /raw kick [lindex [args] 0] [lindex [args] 1] :\002$version\002: Net Hacked Opz, donut do that.
        logevent channel "Server [get_cookie Split(Server)] Opted [lindex [args] 1] (nethacked) on [lindex [args] 0]"
      }
    } elseif {[string first bitch [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && ![matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] o] && ![matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] o [lindex [args] 0]]} {
        display "[get_cookie Char](\002Mode\\[lindex [args] 0]\002) +o [color nick][lindex [args] 1][color default] by [color nick][nick][color default] (illegal)"
        /raw mode [lindex [args] 0] -o [lindex [args] 1]
        logevent channel "[nick] ([user]@[host]) Opted [lindex [args] 1] (invalid) on [lindex [args] 0]"
      }
    } {#display "[get_cookie Char](\002Mode\\[lindex [args] 0]\002) +o [color nick][lindex [args] 1][color default] by [color nick][nick]"}
  }
  complete
}
on mode-o {
  global version
  set id [chanid [lindex [args] 0]]
  if {[lindex [args] 1] == [my_nick]} {
    display "[get_cookie Char][color nick][nick] [color ctcp]([user]@[host])[color change] De-Opted you on [color nick][lindex [args] 0]"
    logevent personal "[nick] ([user]@[host]) De-Opted you on [lindex [args] 0]"
  } elseif {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[string first protect [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && [matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] p] || [matchattr [nick2hand [lindex [args] 1] [lindex [args] 0]] p [lindex [args] 0]]} {
        display "[get_cookie Char]Mode -o [color nick][nick][color default] deopted [color nick][lindex [args] 1][color default] (protected) on [color nick][lindex [args] 0]" status
        /raw mode [lindex [args] 0] -o+o [nick] [lindex [args] 1]
        /raw kick [lindex [args] 0] [nick] :\002$version\002: Protected user, donut do that.
        logevent channel "[nick] ([user]@[host]) De-Opted [lindex [args] 1] (protected) on [lindex [args] 0]"
      }
    }
  }
  complete
}
on mode+b {
  global version
  set id [chanid [lindex [args] 0]]
  if {![info exists banlist([string tolower [lindex [args] 0]])]} {set banlist([string tolower [lindex [args] 0]]) "" ; /raw mode [lindex [args] 0] +b} {
    lappend banlist([string tolower [lindex [args] 0]]) "[lindex [args] 1] [string tolower [nick]![user]@[host]] [clock seconds]"
  }
  if {[nick] != [my_nick] && [string match [lindex [args] 1] [my_nick]![my_user]@[my_host]]} {
    display "[get_cookie Char][color nick][nick] [color ctcp]([user]@[host])[color change] Banned you on [color nick][lindex [args] 0]"
    logevent personal "[nick] ([user]@[host]) Banned you on [lindex [args] 0]"
  } elseif {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[string first protect [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {[nick] != [my_nick] && [matchattr [nick2hand [finduser [lindex [args] 1]] [lindex [args] 0]] p] || [matchattr [nick2hand [finduser [lindex [args] 1]] [lindex [args] 0]] p [lindex [args] 0]]} {
        display "[get_cookie Char]Mode +b [color nick][nick][color default] banned [color nick][lindex [args] 1][color default] (protected) on [color nick][lindex [args] 0]"
        /raw mode [lindex [args] 0] -ob [nick] [lindex [args] 1]
        /raw kick [lindex [args] 0] [nick] :\002$version\002: Protected user, donut do that.
        logevent channel "[nick] ([user]@[host]) Banned [lindex [args] 1] (protected) on [lindex [args] 0]"
      }
    }
  }
  complete
}
on mode-b {
  if {![info exists banlist([string tolower [lindex [args] 0]])]} {set banlist([string tolower [lindex [args] 0]]) "" ; /raw mode [lindex [args] 0] +b}
  if {[nick] != [my_nick] && [string match [lindex [args] 1] [my_nick]![my_user]@[my_host]]} {
    display "[get_cookie Char][color nick][nick] [color ctcp]([user]@[host])[color change] Banned you on [color nick][lindex [args] 0]"
    logevent personal "[nick] ([user]@[host]) Banned you on [lindex [args] 0]"
  }
  for {set bl 0} {$bl < [llength $banlist([string tolower [lindex [args] 0]])]} {incr bl} {
    set id [chanid [lindex [args] 0]]
    if {$id != -1} {set banlist([string tolower [lindex [args] 0]]) [lreplace $banlist([string tolower [lindex [args] 0]]) $bl $bl]}
  }
  complete
}
on mode+k {
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[nick] != [my_nick] && [string first lockmode [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      display "[get_cookie Char]Unauthorized Mode Change ([color nick][lindex [args] 1][color default]) on [color nick][lindex [args] 0]"
      /raw mode [lindex [args] 0] [get_cookie ChannelModes([string tolower [lindex [args] 0]])]
      logevent channel "[nick] ([user]@[host]) Changed Mode (locked) on [lindex [args] 0] ([join [string range [lrange [chk4spec [raw_args]] 1 end] 1 end]])"
    }
  }
  set_cookie ChannelKey([string tolower [lindex [args] 0]]) [lindex [args] 1]
  complete
}
on mode-k {
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
    if {[nick] != [my_nick] && [string first lockmode [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      display "[get_cookie Char]Unauthorized Mode Change ([color nick][lindex [args] 1][color default]) on [color nick][lindex [args] 0]"
      /raw mode [lindex [args] 0] [get_cookie ChannelModes([string tolower [lindex [args] 0]])]
      logevent channel "[nick] ([user]@[host]) Changed Mode (locked) on [lindex [args] 0] ([join [string range [lrange [chk4spec [raw_args]] 1 end] 1 end]])"
    }
  }
  set_cookie ChannelKey([string tolower [lindex [args] 0]]) ""
  complete
}
on mode {
  display "[get_cookie Char](\002Mode\\[lindex [args] 0]\002) [lindex [args] 1] [color nick][join [lrange [args] 2 end]][color change] by [color nick][nick]"
  complete
}
on topic {
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  echo "[color change][get_cookie Char]Topic changed to [color ctcp]\"[join [string range [lrange [chk4spec [raw_args]] 1 end] 1 end]]\"[color change] by [color nick][nick]" channel [lindex [args] 0]
  set id [chanid [lindex [args] 0]]
  if {$id != -1} {
    if {[isop [my_nick] [lindex [args] 0]] && [string first locktopic [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      display "[get_cookie Char]Unauthorized Topic Change ([color nick][join [string range [lrange [chk4spec [raw_args]] 1 end] 1 end]][color default]) on [color nick][lindex [args] 0]"
      /raw topic [lindex [args] 0] [get_cookie ChannelTopic([lindex [get_cookie Channel(Channels)] $id])]
      logevent channel "[nick] ([user]@[host]) Changed Topic (locked) on [lindex [args] 0] ([join [string range [lrange [chk4spec [raw_args]] 1 end] 1 end]])"
    }
  }
  complete
}
on notice {
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  if {[matchignore All $addresslist([string tolower $nick])] || \
      [matchignore Notice $addresslist([string tolower $nick])]} {
    complete ; return
  }
  set args [chk4spec [raw_args]]
  if {[lindex $args 5] == "KILL"} {
    if {[lsearch [split [lindex [split [join $args]] 10] .] irc*] != -1 || [lsearch [split [lindex [split [join $args]] 10] .] *efnet*] != -1 || [lsearch [split [lindex [split [join $args]] 10] .] *edu] != -1} {
      display "[color ctcp][get_cookie Char]Serverkill [color nick][string trimright [lindex [split [join $args]] 8] .][color ctcp] was killed by [color nick][lindex [split [join $args]] 10][color ctcp] [join [lrange [split [join $args]] 13 end]]"
    } {
      display "[color ctcp][get_cookie Char]Operkill [color nick][string trimright [lindex [split [join $args]] 8] .][color ctcp] was killed by [color nick][lindex [split [join $args]] 10][color ctcp] [join [lrange [split [join $args]] 13 end]]"
      if {[get_cookie Toggle(OperKill)] == 1} {addoperkill [lindex [split [join $args]] 10]}
    }
  } {
    display "[color ctcp][lrange [lindex [args] 1] 1 end]"
  }
  complete
}
on timer {
  if {[clock format [clock seconds] -format "%M%S"] == "0000"} {saveuserfile}
  if {[info exists socket]} {chksocket}
  if {[string tolower [get_cookie Away(pager)]] == "on"} {pager}
  if {[info exists channel_textflood] || [info exists channel_nickflood]} {
    if {![info exists flood_timer]} {set flood_timer 0} {incr flood_timer}
    if {$flood_timer >= 4} {
      foreach user [array names channel_textflood] {
        if {$channel_textflood($user) == 0} {unset channel_textflood($user)} {incr channel_textflood($user) -1}
      }
      foreach user [array names channel_nickflood] {
        if {$channel_nickflood($user) == 0} {unset channel_nickflood($user)} {incr channel_nickflood($user) -1}
      }
      if {$chantextflood == ""} {unset channel_textflood}
      if {$channickflood == ""} {unset channel_nickflood}
      set flood_timer 0
    }
  }
  if {[get_cookie Display(Output)]} {
    if {[window_type] == "channel" && [window_name] != [get_cookie ChannelWindow]} {
      set_cookie ChannelWindow [window_name]
    }
  }
  if {[info exists XDCCqueue]} {
    if {![info exists XDCCsleep]} {set XDCCsleep 0} {incr XDCCsleep}
    if {$XDCCsleep >= 20} {
      set XDCCsleep 0
      set_cookie XDCC(Track) 0
      if {[array size XDCCqueue] > 0} {XDCCqueue process}
    }
  }
  if {[get_cookie Toggle(RegainNick)] == 1 && [connected]} {
    if {![info exists regaintimer]} {set regaintimer 0} {incr regaintimer}
    if {$regaintimer >= 30} {
      if {[string compare [string tolower [my_nick]] [string tolower [get_cookie RegainNick(Nick)]]] != 0} {/raw whois [get_cookie RegainNick(Nick)]}
      set regaintimer 0
    }
  }
  if {[get_cookie Toggle(Notify-Go)] == 1 && [connected]} {
    if {![info exists notifytimer]} {set notifytimer 0} {incr notifytimer}
    if {[file mtime [gdx][get_cookie DatFile(Notify)]] != [get_cookie Notify(FileMtime)]} {opennotify}
    if {$notifytimer >= 45 && [get_cookie Notify(CurrentList)] != ""} {/raw ison [join [chk4spec [get_cookie Notify(CurrentList)]]] ; set notifytimer 0}
  }
}
on ctcp {
  global ashift
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  if {[matchignore All $addresslist([string tolower $nick])] || \
      [matchignore CTCP $addresslist([string tolower $nick])]} {
    complete ; return
  }
  if {$nick != [my_nick] && [string tolower [lindex [args] 1]] != "action"} {
    if {$ashift == "on"} {icps}
    set_cookie CTCP-Last(Type) [string toupper [lindex [args] 1]]
    set_cookie CTCP-Last(From) "$nick ($user@$host)"
  }
  switch [string tolower [lindex [args] 1]] {
    "action" {
      set hilited_text 0
      set chan [lindex [join [args]] 0]
      if {[string index [string tolower $chan] 0] == "#"} {
        if {[get_cookie Toggle(Hilite)] == 1 && [get_cookie Hilite(Words)] != ""} {
          foreach word [get_cookie Hilite(Words)] {
            if {[lsearch [list [string tolower [lrange [args] 1 end]]] [string tolower *$word*]] != -1} {
              echo "[color nick]* $nick [color highlight][join [lrange [args] 2 end]]" channel $chan ; set hilited_text 1 ; break
            }
          }
          if {$hilited_text == 0} {echo "[color nick]* $nick [color default][join [lrange [args] 2 end]]" channel $chan}
        } {
          echo "[color nick]* $nick [color default][join [lrange [args] 2 end]]" channel $chan
        }
      } {
        set win [window_name]
        add_query $nick
        if {[string tolower $chan] == [string tolower [my_nick]]} {
          if {[lsearch [string tolower [queries]] [string tolower [chk4spec $nick]]] != -1} {
            echo "[color nick]* [chk4spec $nick] [color default][join [lrange [args] 2 end]]" query [chk4spec $nick]
          } {
            if {[window_type] == "status" || [window_type] == "chat"} {
              /query [chk4spec $nick] min ; echo "[color nick]* [chk4spec $nick] [color default][join [lrange [args] 2 end]]" query [chk4spec $nick]
            } {
              echo "[color default]*[color nick][chk4spec $nick] [color ctcp]($user@$host)[color default]* [join [lrange [args] 2 end]]" channel $win
            }
          }
        }
        if {[get_cookie Toggle(Away-[lindex [server] 0])] == 1} {logmsgs *[chk4spec $nick] $user@$host [join [lrange [args] 2 end]]}
      }
      actionflood_chk [chk4spec $nick] $chan
    }
    "clientinfo" {
      if {[string index [lindex [args] 0] 0] == "#"} {
        echo "[color ctcp][get_cookie Char][color nick][nick][color ctcp] clientinfoed everyone in [color nick][lindex [args] 0]" channel [lindex [args] 0]
      }
      if {[lindex [args] 2] == ""} {
        /raw NOTICE $nick :\001CLIENTINFO [get_cookie CTCP(Clientinfo)]\001
      }
      if {[info exists [get_cookie CTCP-Clientinfo([lindex [args] 2])]]} {
        /raw NOTICE $nick :\001CLIENTINFO [get_cookie CTCP-Clientinfo([lindex [args] 2])]\001
      } {
        if {[lindex [args] 2] != ""} {
          /raw NOTICE $nick :\001ERRMSG CLIENTINFO: [lindex [args] 2] is not a valid function\001
        }
      }
    }
    "dcc" {
      switch [string tolower [lindex [raw_args] 2]] {
        "send" {
          if {[lindex [raw_args] 6] <= 0} {
            /ignore [nick]
            display "[color ctcp][get_cookie Char]Invalid DCC SEND /dev/zero from [color nick][nick] [color ctcp]([user]@[host])"
            complete
          } {return}
        }
        "tsend" {
          if {[lindex [raw_args] 6] <= 0} {
            /ignore [nick]
            display "[color ctcp][get_cookie Char]Invalid DCC SEND /dev/zero from [color nick][nick] [color ctcp]([user]@[host])"
            complete
          } {return}
        }
        "chat" {return}
        "resume" {return}
        default {
          /ignore [nick]
          display "[color ctcp][get_cookie Char]Invalid DCC attempt from [color nick][nick] [color ctcp]([user]@[host])"
        }
      }
    }
    "xdcc" {
      switch [string tolower [lindex [lindex [args] 2] 0]] {
        "send" {
          if {![get_cookie XDCC(Offering)]} {set replyline "XDCC Offering Disabled"
          } elseif {[get_cookie XDCC(#1)Packet] == ""} {set replyline "No XDCC Packets Available"
          } elseif {[expr [get_cookie XDCC(Sockets)] - [dcc_count]] < 0} {set replyline "No Available XDCC Sockets"
          } elseif {[get_cookie XDCC(#[string trim [lindex [lindex [args] 2] 1] #])Packet] == ""} {set replyline "No Such XDCC Packet"}
          if {[info exists replyline]} {/raw notice $nick :$replyline
          } {
            set packet "#[string trim [lindex [lindex [args] 2] 1] #]"
            logevent xdcc "$nick ([user]@[host]) requested XDCC Send Packet $packet"
            xdcc send $nick $packet
          }
        }
        "list" {
          if {![get_cookie XDCC(Offering)]} {set replyline "XDCC Offering Disabled"
          } elseif {[get_cookie XDCC(#1)Packet] == ""} {set replyline "No Available XDCC Packets"}
          if {[info exists replyline]} {/raw notice $nick :$replyline
          } {xdcc offer $nick}
          logevent xdcc "$nick ([user]@[host]) requested XDCC Offer List"
        }
        default {
          if {[string index [lindex [args] 0] 0] == "#"} {
            echo "[color ctcp][get_cookie Char][color nick][nick][color ctcp] xdcced everyone in [color nick][lindex [args] 0]" channel [lindex [args] 0]
          }
          /raw NOTICE $nick :\001XDCC [get_cookie CTCP(XDCC)]\001
        }
      }
    }
    "sed" {
      if {[string index [lindex [args] 0] 0] == "#"} {
        echo "[color ctcp][get_cookie Char][color nick][nick][color ctcp] seded everyone in [color nick][lindex [args] 0]" channel [lindex [args] 0]
      }
      /raw NOTICE $nick :\001SED [get_cookie CTCP(Sed)]\001
    }
    "version" {
      if {[string index [lindex [args] 0] 0] == "#"} {
        echo "[color ctcp][get_cookie Char][color nick][nick][color ctcp] versioned everyone in [color nick][lindex [args] 0]"  channel [lindex [args] 0]
      }
      /raw NOTICE $nick :\001VERSION [get_cookie CTCP(Version)]\001
    }
    default {
      if {[string index [lindex [args] 0] 0] == "#"} {
        echo "[color ctcp][get_cookie Char][color nick][nick][color ctcp] [string tolower [lindex [args] 1]]ed everyone in [color nick][lindex [args] 0]" channel [lindex [args] 0]
      }
      return
    }
  }
  if {[string tolower [lindex [args] 1]] != "action"} {
    logevent personal [nick] ([user]@[host]) [string tolower [lindex [args] 1]]ed you ([lindex [args] 1])
  }
  complete
}
on ctcpreply {
  echo "0-[lindex [args] 0] 1-[lindex [args] 1] 2-[lindex [args] 2] 3-[lindex [args] 3] 4-[lindex [args] 4]" status
  return
}
on privmsg {
  global version
  set nick [nick]
  set user [user]
  set host [host]
  addresslist $nick $user $host
  if {[matchignore All $addresslist([string tolower $nick])]} {
    complete ; return
  }
  set chan [lindex [args] 0]
  set hilited_text 0
  if {[string index [string tolower $chan] 0] == "&" || [string index [string tolower $chan] 0] == "#"} {
    if {[matchignore Public $addresslist([string tolower $nick])]} {
      complete ; return
    }
    set id [chanid [lindex [args] 0]]
    if {$id != -1} {
      if {[string first moderate [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
        if {[isop $nick $chan] || [isvoc $nick $chan]} {
          if {[get_cookie Toggle(Hilite)] == 1 && [get_cookie Hilite(Words)] != ""} {
            foreach word [get_cookie Hilite(Words)] {
              if {[lsearch [list [string tolower [lrange [args] 1 end]]] [string tolower *$word*]] != -1} {
                echo "\[[color highlight]\002MoD\002\] [color nick]<$nick> [color highlight][join [lrange [args] 1 end]]" channel $chan ; set hilited_text 1 ; break
              }
            }
            if {$hilited_text == 0} {echo "\[[color highlight]\002MoD\002\] [color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan}
          } {
            echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan
          }
        }
      } {
        if {[get_cookie Toggle(Hilite)] == 1 && [get_cookie Hilite(Words)] != ""} {
          foreach word [get_cookie Hilite(Words)] {
            if {[lsearch [list [string tolower [lrange [args] 1 end]]] [string tolower *$word*]] != -1} {
              echo "[color nick]<$nick> [color highlight][join [lrange [args] 1 end]]" channel $chan ; set hilited_text 1 ; break
            }
          }
          if {$hilited_text == 0} {echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan}
        } {
          echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan
        }
      }
    } {
      if {[get_cookie Toggle(Hilite)] == 1 && [get_cookie Hilite(Words)] != ""} {
        foreach word [get_cookie Hilite(Words)] {
          if {[lsearch [list [string tolower [lrange [args] 1 end]]] [string tolower *$word*]] != -1} {
            echo "[color nick]<$nick> [color highlight][join [lrange [args] 1 end]]" channel $chan ; set hilited_text 1 ; break
          }
        }
        if {$hilited_text == 0} {echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan}
      } {
        echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" channel $chan
      }
    }
    set id [chanid [lindex [args] 0]]
    if {$id != -1 && [isop [my_nick] [lindex [args] 0]]} {
      if {[string first shitlist [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
        if {[nick] != [my_nick] && [matchattr [nick2hand [nick] [lindex [args] 0]] b] || [matchattr [nick2hand [nick] [lindex [args] 0]] b [lindex [args] 0]]} {
          echo "Shitlisted user [color nick][nick][color default] (valid) on [color nick][lindex [args] 0]" status
          /raw mode [lindex [args] 0] +b [getmask [nick]![user]@[host] 3]
          /raw kick [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
        } elseif {[nick] != [my_nick] && [matchattr [nick2hand [nick] [lindex [args] 0]] k] || [matchattr [nick2hand [nick] [lindex [args] 0]] k [lindex [args] 0]]} {
          echo "Shitlisted user [color nick][nick][color default] (valid) on [color nick][lindex [args] 0]" status
          /ban -u3 [getmask [nick]![user]@[host] 3]
          /raw kick [lindex [args] 0] :\002$version\002: Shitlisted, seeya.
        }
      }
    }
    textflood_chk [chk4spec $nick] $chan
    wordkick_chk [chk4spec $nick] $chan [join [lrange [args] 1 end]]
    textrepeat_chk [chk4spec $nick] $chan [join [lrange [args] 1 end]]
  } {
    if {[matchignore Query $addresslist([string tolower $nick])]} {
      complete ; return
    } elseif {[string tolower [lindex [args] 1]] == "op"} {msgop [nick] [user]@[host] [lrange [args] 2 end]
    } elseif {[string tolower [lindex [args] 1]] == "deop"} {msgdeop [nick] [user]@[host] [lrange [args] 2 end]
    } elseif {[string tolower [lindex [args] 1]] == "ban"} {msgban [nick] [user]@[host] [lrange [args] 2 end]
    } elseif {[string tolower [lindex [args] 1]] == "unban"} {msgunban [nick] [user]@[host] [lrange [args] 2 end]
    } elseif {[string tolower [lindex [args] 1]] == "ident"} {msgident [nick] [user]@[host] [lrange [args] 2 end]
    } elseif {[string tolower [lindex [args] 1]] == "pass"} {msgpass [nick] [user]@[host] [lrange [args] 2 end]
    } {
      add_query [nick]
      add_carbon [nick] "($user@$host) [lrange [args] 1 end]"
      if {[string tolower $chan] == [string tolower [my_nick]]} {
        if {[lsearch [string tolower [queries]] [string tolower [chk4spec $nick]]] != -1} {
          echo "[color nick]<$nick> [color default][join [lrange [args] 1 end]]" query [chk4spec $nick]
        } {
          if {[window_type] == "status" || [window_type] == "chat"} {
            /query [nick] min ; echo "[color nick]<[nick]> [color default][join [lrange [args] 1 end]]" query [chk4spec $nick]
          } {
            echo "[color default]*[color nick]$nick [color ctcp]($user@$host)[color default]* [join [lrange [args] 1 end]]" channel [window_name]
          }
        }
      }
      if {[get_cookie Toggle(Away-[lindex [server] 0])] == 1} {logmsgs $nick $user@$host [join [lrange [args] 1 end]]}
    }
  }
  addresslist $nick $user $host
  complete
}
on chat_text {
  set nick [nick]
  set hilited_text 0
  if {[get_cookie Toggle(Hilite)] == 1 && [get_cookie Hilite(Words)] != ""} {
    foreach word [get_cookie Hilite(Words)] {
      if {[lsearch [list [string tolower [lrange [args] 0 end]]] [string tolower *$word*]] != -1} {
        echo "[color nick]<$nick> [color highlight][join [lrange [args] 0 end]]" chat $nick ; set hilited_text 1 ; break
      }
    }
    if {$hilited_text == 0} {echo "[color nick]<$nick> [color default][join [lrange [args] 0 end]]" chat $nick}
  } {
    echo "[color nick]<$nick> [color default][join [lrange [args] 0 end]]" chat $nick
  }
  complete
}
on lookup {
  set request [lindex [args] 0]
  set result [lindex [args] 1]
  if {[string length $result]} {
    if {![get_cookie Lookup(LongIP)]} {
      display "[get_cookie Char]Resolved [color nick]$request[color default] to [color nick]$result"
    } {
      /longip $result
    }
  } {
    display "[get_cookie Char]Could not resolve [color nick]$request"
  }
}
on whois {
  echo "++ [args]" status
  set nick [string tolower [nick]]
  set i [lsearch [get_cookie Lookup(DNS)] $nick]
  while {$i > -1} {
    lookup [host]
    display "[get_cookie Char]Attempting to resolve [color nick][host]"
    set_cookie Lookup(DNS) [lreplace [get_cookie Lookup(DNS)] $i $i]
    set i [lsearch [get_cookie Lookup(DNS)] $nick]
  }
}
on url_select {
  if {[get_cookie Toggle(URL's)]} {
    display "[get_cookie Char][color notice]Added [color url][lindex [args] 0][color notice] to Netscapes Bookmarks"
    set id [open [chk4spec [get_cookie Directory(URLS)]] a]
    addsocket $id
    puts $id "<DT><A HREF=\"[lindex [args] 0]\" ADD_DATE=\"[clock seconds]\">[lindex [args] 0]</A>"
    close $id
    killsocket $id
    complete
  } {return}
}

### numerics
#   echo "0-[lindex [args] 0] 1-[lindex [args] 1] 2-[lindex [args] 2] 3-[lindex [args] 3] 4-[lindex [args] 4]" status
on 001 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 002 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 003 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 004 {display "[get_cookie Char][lrange [args] 1 end]" ; complete}
on 005 {
  display "005[get_cookie Char][args]"
  return
}
on 006 {
  display "006[get_cookie Char][args]"
  return
}
on 007 {
  display "007[get_cookie Char][args]"
  return
}
on 008 {
  display "008[get_cookie Char][args]"
  return
}
on 009 {
  display "009[get_cookie Char][args]"
  return
}
on 010 {
  display "010[get_cookie Char][args]"
  return
}
on 011 {
  display "011[get_cookie Char][args]"
  return
}
on 012 {
  display "012[get_cookie Char][args]"
  return
}
on 013 {
  display "013[get_cookie Char][args]"
  return
}
on 014 {
  display "014[get_cookie Char][args]"
  return
}
on 015 {
  display "016[get_cookie Char][args]"
  return
}
on 017 {
  display "017[get_cookie Char][args]"
  return
}
on 018 {
  display "018[get_cookie Char][args]"
  return
}
on 019 {
  display "019[get_cookie Char][args]"
  return
}
on 020 {
  display "020[get_cookie Char][args]"
  return
}
on 021 {
  display "021[get_cookie Char][args]"
  return
}
on 022 {
  display "022[get_cookie Char][args]"
  return
}
on 023 {
  display "023[get_cookie Char][args]"
  return
}
on 024 {
  display "024[get_cookie Char][args]"
  return
}
on 025 {
  display "025[get_cookie Char][args]"
  return
}
on 026 {
  display "026[get_cookie Char][args]"
  return
}
on 027 {
  display "027[get_cookie Char][args]"
  return
}
on 028 {
  display "028[get_cookie Char][args]"
  return
}
on 029 {
  display "029[get_cookie Char][args]"
  return
}
on 030 {
  display "030[get_cookie Char][args]"
  return
}
on 031 {
  display "031[get_cookie Char][args]"
  return
}
on 032 {
  display "032[get_cookie Char][args]"
  return
}
on 033 {
  display "033[get_cookie Char][args]"
  return
}
on 034 {
  display "034[get_cookie Char][args]"
  return
}
on 035 {
  display "035[get_cookie Char][args]"
  return
}
on 036 {
  display "036[get_cookie Char][args]"
  return
}
on 037 {
  display "037[get_cookie Char][args]"
  return
}
on 038 {
  display "038[get_cookie Char][args]"
  return
}
on 039 {
  display "039[get_cookie Char][args]"
  return
}
on 040 {
  display "040[get_cookie Char][args]"
  return
}
on 041 {
  display "041[get_cookie Char][args]"
  return
}
on 042 {
  display "042[get_cookie Char][args]"
  return
}
on 043 {
  display "043[get_cookie Char][args]"
  return
}
on 044 {
  display "044[get_cookie Char][args]"
  return
}
on 045 {
  display "045[get_cookie Char][args]"
  return
}
on 046 {
  display "046[get_cookie Char][args]"
  return
}
on 047 {
  display "047[get_cookie Char][args]"
  return
}
on 048 {
  display "048[get_cookie Char][args]"
  return
}
on 049 {
  display "049[get_cookie Char][args]"
  return
}
on 050 {
  display "050[get_cookie Char][args]"
  return
}
on 051 {
  display "051[get_cookie Char][args]"
  return
}
on 052 {
  display "052[get_cookie Char][args]"
  return
}
on 053 {
  display "053[get_cookie Char][args]"
  return
}
on 054 {
  display "054[get_cookie Char][args]"
  return
}
on 055 {
  display "055[get_cookie Char][args]"
  return
}
on 056 {
  display "056[get_cookie Char][args]"
  return
}
on 057 {
  display "057[get_cookie Char][args]"
  return
}
on 058 {
  display "058[get_cookie Char][args]"
  return
}
on 059 {
  display "059[get_cookie Char][args]"
  return
}
on 060 {
  display "060[get_cookie Char][args]"
  return
}
on 061 {
  display "061[get_cookie Char][args]"
  return
}
on 062 {
  display "062[get_cookie Char][args]"
  return
}
on 063 {
  display "063[get_cookie Char][args]"
  return
}
on 064 {
  display "064[get_cookie Char][args]"
  return
}
on 065 {
  display "065[get_cookie Char][args]"
  return
}
on 066 {
  display "066[get_cookie Char][args]"
  return
}
on 067 {
  display "067[get_cookie Char][args]"
  return
}
on 068 {
  display "068[get_cookie Char][args]"
  return
}
on 069 {
  display "069[get_cookie Char][args]"
  return
}
on 070 {
  display "070[get_cookie Char][args]"
  return
}
on 071 {
  display "071[get_cookie Char][args]"
  return
}
on 072 {
  display "072[get_cookie Char][args]"
  return
}
on 073 {
  display "073[get_cookie Char][args]"
  return
}
on 074 {
  display "074[get_cookie Char][args]"
  return
}
on 075 {
  display "075[get_cookie Char][args]"
  return
}
on 076 {
  display "076[get_cookie Char][args]"
  return
}
on 077 {
  display "077[get_cookie Char][args]"
  return
}
on 078 {
  display "078[get_cookie Char][args]"
  return
}
on 079 {
  display "079[get_cookie Char][args]"
  return
}
on 080 {
  display "080[get_cookie Char][args]"
  return
}
on 081 {
  display "081[get_cookie Char][args]"
  return
}
on 082 {
  display "082[get_cookie Char][args]"
  return
}
on 083 {
  display "083[get_cookie Char][args]"
  return
}
on 084 {
  display "084[get_cookie Char][args]"
  return
}
on 085 {
  display "085[get_cookie Char][args]"
  return
}
on 086 {
  display "086[get_cookie Char][args]"
  return
}
on 087 {
  display "087[get_cookie Char][args]"
  return
}
on 088 {
  display "088[get_cookie Char][args]"
  return
}
on 089 {
  display "089[get_cookie Char][args]"
  return
}
on 090 {
  display "090[get_cookie Char][args]"
  return
}
on 091 {
  display "091[get_cookie Char][args]"
  return
}
on 092 {
  display "092[get_cookie Char][args]"
  return
}
on 093 {
  display "093[get_cookie Char][args]"
  return
}
on 094 {
  display "094[get_cookie Char][args]"
  return
}
on 095 {
  display "095[get_cookie Char][args]"
  return
}
on 096 {
  display "096[get_cookie Char][args]"
  return
}
on 097 {
  display "097[get_cookie Char][args]"
  return
}
on 098 {
  display "098[get_cookie Char][args]"
  return
}
on 099 {
  display "099[get_cookie Char][args]"
  return
}
on 100 {
  display "100[get_cookie Char][args]"
  return
}
on 101 {
  display "101[get_cookie Char][args]"
  return
}
on 102 {
  display "102[get_cookie Char][args]"
  return
}
on 103 {
  display "103[get_cookie Char][args]"
  return
}
on 104 {
  display "104[get_cookie Char][args]"
  return
}
on 105 {
  display "105[get_cookie Char][args]"
  return
}
on 106 {
  display "106[get_cookie Char][args]"
  return
}
on 107 {
  display "107[get_cookie Char][args]"
  return
}
on 108 {
  display "108[get_cookie Char][args]"
  return
}
on 109 {
  display "109[get_cookie Char][args]"
  return
}
on 110 {
  display "110[get_cookie Char][args]"
  return
}
on 111 {
  display "111[get_cookie Char][args]"
  return
}
on 112 {
  display "112[get_cookie Char][args]"
  return
}
on 113 {
  display "113[get_cookie Char][args]"
  return
}
on 114 {
  display "114[get_cookie Char][args]"
  return
}
on 115 {
  display "115[get_cookie Char][args]"
  return
}
on 116 {
  display "116[get_cookie Char][args]"
  return
}
on 117 {
  display "117[get_cookie Char][args]"
  return
}
on 118 {
  display "118[get_cookie Char][args]"
  return
}
on 119 {
  display "119[get_cookie Char][args]"
  return
}
on 120 {
  display "120[get_cookie Char][args]"
  return
}
on 121 {
  display "121[get_cookie Char][args]"
  return
}
on 122 {
  display "122[get_cookie Char][args]"
  return
}
on 123 {
  display "123[get_cookie Char][args]"
  return
}
on 124 {
  display "124[get_cookie Char][args]"
  return
}
on 125 {
  display "125[get_cookie Char][args]"
  return
}
on 126 {
  display "126[get_cookie Char][args]"
  return
}
on 127 {
  display "127[get_cookie Char][args]"
  return
}
on 128 {
  display "128[get_cookie Char][args]"
  return
}
on 129 {
  display "129[get_cookie Char][args]"
  return
}
on 130 {
  display "130[get_cookie Char][args]"
  return
}
on 131 {
  display "131[get_cookie Char][args]"
  return
}
on 132 {
  display "132[get_cookie Char][args]"
  return
}
on 133 {
  display "133[get_cookie Char][args]"
  return
}
on 134 {
  display "134[get_cookie Char][args]"
  return
}
on 135 {
  display "135[get_cookie Char][args]"
  return
}
on 136 {
  display "136[get_cookie Char][args]"
  return
}
on 137 {
  display "137[get_cookie Char][args]"
  return
}
on 138 {
  display "138[get_cookie Char][args]"
  return
}
on 139 {
  display "139[get_cookie Char][args]"
  return
}
on 140 {
  display "140[get_cookie Char][args]"
  return
}
on 141 {
  display "141[get_cookie Char][args]"
  return
}
on 142 {
  display "142[get_cookie Char][args]"
  return
}
on 143 {
  display "143[get_cookie Char][args]"
  return
}
on 144 {
  display "144[get_cookie Char][args]"
  return
}
on 145 {
  display "145[get_cookie Char][args]"
  return
}
on 146 {
  display "146[get_cookie Char][args]"
  return
}
on 147 {
  display "147[get_cookie Char][args]"
  return
}
on 148 {
  display "148[get_cookie Char][args]"
  return
}
on 149 {
  display "149[get_cookie Char][args]"
  return
}
on 150 {
  display "150[get_cookie Char][args]"
  return
}
on 151 {
  display "151[get_cookie Char][args]"
  return
}
on 152 {
  display "152[get_cookie Char][args]"
  return
}
on 153 {
  display "153[get_cookie Char][args]"
  return
}
on 154 {
  display "154[get_cookie Char][args]"
  return
}
on 155 {
  display "155[get_cookie Char][args]"
  return
}
on 156 {
  display "156[get_cookie Char][args]"
  return
}
on 157 {
  display "157[get_cookie Char][args]"
  return
}
on 158 {
  display "158[get_cookie Char][args]"
  return
}
on 159 {
  display "159[get_cookie Char][args]"
  return
}
on 160 {
  display "160[get_cookie Char][args]"
  return
}
on 161 {
  display "161[get_cookie Char][args]"
  return
}
on 162 {
  display "162[get_cookie Char][args]"
  return
}
on 163 {
  display "163[get_cookie Char][args]"
  return
}
on 164 {
  display "164[get_cookie Char][args]"
  return
}
on 165 {
  display "165[get_cookie Char][args]"
  return
}
on 166 {
  display "166[get_cookie Char][args]"
  return
}
on 167 {
  display "167[get_cookie Char][args]"
  return
}
on 168 {
  display "168[get_cookie Char][args]"
  return
}
on 169 {
  display "169[get_cookie Char][args]"
  return
}
on 170 {
  display "170[get_cookie Char][args]"
  return
}
on 171 {
  display "171[get_cookie Char][args]"
  return
}
on 172 {
  display "172[get_cookie Char][args]"
  return
}
on 173 {
  display "173[get_cookie Char][args]"
  return
}
on 174 {
  display "174[get_cookie Char][args]"
  return
}
on 175 {
  display "175[get_cookie Char][args]"
  return
}
on 176 {
  display "176[get_cookie Char][args]"
  return
}
on 177 {
  display "177[get_cookie Char][args]"
  return
}
on 178 {
  display "178[get_cookie Char][args]"
  return
}
on 179 {
  display "179[get_cookie Char][args]"
  return
}
on 180 {
  display "180[get_cookie Char][args]"
  return
}
on 181 {
  display "181[get_cookie Char][args]"
  return
}
on 182 {
  display "182[get_cookie Char][args]"
  return
}
on 183 {
  display "183[get_cookie Char][args]"
  return
}
on 184 {
  display "184[get_cookie Char][args]"
  return
}
on 185 {
  display "185[get_cookie Char][args]"
  return
}
on 186 {
  display "186[get_cookie Char][args]"
  return
}
on 187 {
  display "187[get_cookie Char][args]"
  return
}
on 188 {
  display "188[get_cookie Char][args]"
  return
}
on 189 {
  display "189[get_cookie Char][args]"
  return
}
on 190 {
  display "190 [get_cookie Char][args]"
  return
}
on 191 {
  display "191[get_cookie Char][args]"
  return
}
on 192 {
  display "192[get_cookie Char][args]"
  return
}
on 193 {
  display "193[get_cookie Char][args]"
  return
}
on 194 {
  display "194[get_cookie Char][args]"
  return
}
on 195 {
  display "195[get_cookie Char][args]"
  return
}
on 196 {
  display "196[get_cookie Char][args]"
  return
}
on 197 {
  display "197[get_cookie Char][args]"
  return
}
on 198 {
  display "198[get_cookie Char][args]"
  return
}
on 199 {
  display "199[get_cookie Char][args]"
  return
}
on 200 {
  display "200[get_cookie Char][args]"
  return
}
on 201 {
  display "201[get_cookie Char][args]"
  return
}
on 202 {
  display "202[get_cookie Char][args]"
  return
}
on 203 {
  display "203[get_cookie Char][args]"
  return
}
on 204 {
  display "204[get_cookie Char][args]"
  return
}
on 205 {
  display "205[get_cookie Char][args]"
  return
}
on 206 {
  display "206[get_cookie Char][args]"
  return
}
on 207 {
  display "207[get_cookie Char][args]"
  return
}
on 208 {
  display "208[get_cookie Char][args]"
  return
}
on 209 {
  display "209[get_cookie Char][args]"
  return
}
on 210 {
  display "210[get_cookie Char][args]"
  return
}
on 211 {
  display "211[get_cookie Char][args]"
  return
}
on 212 {
  display "212[get_cookie Char][args]"
  return
}
on 213 {
  display "213[get_cookie Char][args]"
  return
}
on 214 {
  display "214[get_cookie Char][args]"
  return
}
on 215 {
  display "215[get_cookie Char][args]"
  return
}
on 216 {
  display "216[get_cookie Char][args]"
  return
}
on 217 {
  display "217[get_cookie Char][args]"
  return
}
on 218 {
  display "218[get_cookie Char][args]"
  return
}
on 219 {
  display "219[get_cookie Char][args]"
  return
}
on 220 {
  display "220[get_cookie Char][args]"
  return
}
on 221 {
  display "[color change][get_cookie Char]Your user mode is [color ctcp]\"[lindex [args] 1]\""
  set_cookie Personal(Modes) [string trimleft [lindex [args] 1] +]
  complete
}
on 222 {
  display "222[get_cookie Char][args]"
  return
}
on 223 {
  display "223[get_cookie Char][args]"
  return
}
on 224 {
  display "224[get_cookie Char][args]"
  return
}
on 225 {
  display "225[get_cookie Char][args]"
  return
}
on 226 {
  display "226[get_cookie Char][args]"
  return
}
on 227 {
  display "227[get_cookie Char][args]"
  return
}
on 228 {
  display "228[get_cookie Char][args]"
  return
}
on 229 {
  display "229[get_cookie Char][args]"
  return
}
on 230 {
  display "230[get_cookie Char][args]"
  return
}
on 231 {
  display "231[get_cookie Char][args]"
  return
}
on 232 {
  display "232[get_cookie Char][args]"
  return
}
on 233 {
  display "233[get_cookie Char][args]"
  return
}
on 234 {
  display "234[get_cookie Char][args]"
  return
}
on 235 {
  display "235[get_cookie Char][args]"
  return
}
on 236 {
  display "236[get_cookie Char][args]"
  return
}
on 237 {
  display "237[get_cookie Char][args]"
  return
}
on 238 {
  display "238[get_cookie Char][args]"
  return
}
on 239 {
  display "239[get_cookie Char][args]"
  return
}
on 240 {
  display "240[get_cookie Char][args]"
  return
}
on 241 {
  display "241[get_cookie Char][args]"
  return
}
on 242 {
  display "242[get_cookie Char][args]"
  return
}
on 243 {
  display "243[get_cookie Char][args]"
  return
}
on 244 {
  display "244[get_cookie Char][args]"
  return
}
on 245 {
  display "245[get_cookie Char][args]"
  return
}
on 246 {
  display "246[get_cookie Char][args]"
  return
}
on 247 {
  display "247[get_cookie Char][args]"
  return
}
on 248 {
  display "248[get_cookie Char][args]"
  return
}
on 249 {
  display "249[get_cookie Char][args]"
  return
}
on 250 {
  display "250[get_cookie Char][args]"
  return
}
on 251 {
  display "[get_cookie Char](\002Lusers\002) Network wide stats"
  display "    Users online ([color nick][lindex [lindex [args] 1] 2][color default])"
  display "    Invisible Users online ([color nick][lindex [lindex [args] 1] 5][color default])"
  display "    Total Users online ([color nick][expr [lindex [lindex [args] 1] 5] + [lindex [lindex [args] 1] 2]][color default])"
  display "    Servers connected ([color nick][lindex [lindex [args] 1] 8][color default])"
  complete
}
on 252 {
  display "    [lindex [args] 2] ([color nick][lindex [args] 1][color default])"
  complete
}
on 253 {
  display "253[get_cookie Char][args]"
  return
}
on 254 {
  display "    Channels formed ([color nick][lindex [args] 1][color default])"
  complete
}
on 255 {
  display "    Clients connected ([color nick][lindex [lindex [args] 1] 2][color default])"
  display "    Server connected ([color nick][lindex [lindex [args] 1] 5][color default])"
  complete
}
on 256 {
  display "256[get_cookie Char][args]"
  return
}
on 257 {
  display "257[get_cookie Char][args]"
  return
}
on 258 {
  display "258[get_cookie Char][args]"
  return
}
on 259 {
  display "259[get_cookie Char][args]"
  return
}
on 260 {
  display "260[get_cookie Char][args]"
  return
}
on 261 {
  display "261[get_cookie Char][args]"
  return
}
on 262 {
  display "262[get_cookie Char][args]"
  return
}
on 263 {
  display "263[get_cookie Char][args]"
  return
}
on 264 {
  display "264[get_cookie Char][args]"
  return
}
on 265 {
  display "    Current local users: ([color nick][lindex [lindex [args] 1] 3][color default]) max: ([color nick][lindex [lindex [args] 1] 5][color default])"
  complete
}
on 266 {
  display "    Current global users: ([color nick][lindex [lindex [args] 1] 3][color default]) max: ([color nick][lindex [lindex [args] 1] 5][color default])"
  complete
}
on 267 {
  display "267[get_cookie Char][args]"
  return
}
on 268 {
  display "268[get_cookie Char][args]"
  return
}
on 269 {
  display "269[get_cookie Char][args]"
  return
}
on 270 {
  display "270[get_cookie Char][args]"
  return
}
on 271 {
  display "271[get_cookie Char][args]"
  return
}
on 272 {
  display "272[get_cookie Char][args]"
  return
}
on 273 {
  display "273[get_cookie Char][args]"
  return
}
on 274 {
  display "274[get_cookie Char][args]"
  return
}
on 275 {
  display "275[get_cookie Char][args]"
  return
}
on 276 {
  display "276[get_cookie Char][args]"
  return
}
on 277 {
  display "277[get_cookie Char][args]"
  return
}
on 278 {
  display "278[get_cookie Char][args]"
  return
}
on 279 {
  display "279[get_cookie Char][args]"
  return
}
on 280 {
  display "280[get_cookie Char][args]"
  return
}
on 281 {
  display "281[get_cookie Char][args]"
  return
}
on 282 {
  display "282[get_cookie Char][args]"
  return
}
on 283 {
  display "283[get_cookie Char][args]"
  return
}
on 284 {
  display "284[get_cookie Char][args]"
  return
}
on 285 {
  display "285[get_cookie Char][args]"
  return
}
on 286 {
  display "286[get_cookie Char][args]"
  return
}
on 287 {
  display "287[get_cookie Char][args]"
  return
}
on 288 {
  display "288[get_cookie Char][args]"
  return
}
on 289 {
  display "289[get_cookie Char][args]"
  return
}
on 290 {
  display "290[get_cookie Char][args]"
  return
}
on 291 {
  display "291[get_cookie Char][args]"
  return
}
on 292 {
  display "292[get_cookie Char][args]"
  return
}
on 293 {
  display "293[get_cookie Char][args]"
  return
}
on 294 {
  display "294[get_cookie Char][args]"
  return
}
on 295 {
  display "295[get_cookie Char][args]"
  return
}
on 296 {
  display "296[get_cookie Char][args]"
  return
}
on 297 {
  display "297[get_cookie Char][args]"
  return
}
on 298 {
  display "298[get_cookie Char][args]"
  return
}
on 299 {
  display "299[get_cookie Char][args]"
  return
}
on 300 {
  display "300[get_cookie Char][args]"
  return
}
on 301 {display "    [color nick][lindex [args] 1][color default] is away: [lindex [args] 2]" ; complete}
on 302 {
  if {[string first * [lindex [args] 2]] != -1} {
    set parms [lrange [args] 1 end]
    set nick [string trimright $parms =*]
    set operpos [expr [string length [lindex [args] 2]] - 1]
    display "[get_cookie Char][color nick]$nick [color default]IS an IRCop..."
    unset operpos ; return
  }
  if {[get_cookie Update(IAL-[lindex [server] 0])] == 1} {after [expr [llength [channels]] * 3500] set_cookie Update(IAL-[lindex [server] 0]) 0}
  complete
}
on 303 {
  global notify
  if {![info exists notify]} {opennotify}
  set notifylist [join [array names notify]]
  foreach nick [lindex [args] 1] {
    if {[lsearch [string tolower [get_cookie Notify(ISON-[lindex [server] 0])]] [string tolower [chk4spec $nick]]] == -1} {
      set_cookie Notify(ISON-[lindex [server] 0]) "[get_cookie Notify(ISON-[lindex [server] 0])] $nick"
      display "[get_cookie Char](\002Notify\\Signon\002) [color nick][join [chk4spec $nick]][color default] is on IRC"
      set id [fid [array names notify] [chk4spec $nick]]
      if {[lindex $notify([lindex [array names notify] $id]) 2] != {}} {
        display "    [color nick][join [chk4spec $nick]][color default] (Notes: [lindex $notify([lindex [array names notify] $id]) 2])"
      }
      foreach entry [join [array names notify]] {
        if {[string tolower $entry] == [string tolower $nick]} {
          if {[lindex $notify($entry) 0] == 1 && [get_cookie Notify(Whois)] == 1} {/whois $nick}
          if {[file extension [lindex $notify($entry) 1]] == ".wav" || \
              [file extension [lindex $notify($entry) 1]] == ".mp3"} {
            mmplay [gdw][lindex $notify($entry) 2]
          }
        }
      }
    }
  }
  if {[get_cookie Notify(ISON-[lindex [server] 0])] != ""} {
    if {[string match [string tolower [lindex [args] 1]] [string tolower [get_cookie Notify(ISON-[lindex [server] 0])]]] != "1"} {
      foreach nick [get_cookie Notify(ISON-[lindex [server] 0])] {
        if {[lsearch [string tolower [lindex [args] 1]] [string tolower [chk4spec $nick]]] == -1} {
          if {[lsearch [string tolower [array names notify]] [string tolower [chk4spec $nick]]] != -1} {
            display "[get_cookie Char](\002Notify\\Signoff\002) [color nick][join [chk4spec $nick]][color default] has left IRC"
          }
        }
      }
      set_cookie Notify(ISON-[lindex [server] 0]) [lindex [args] 1]
    }
  } {
    set_cookie Notify(ISON-[lindex [server] 0]) [lindex [args] 1]
  }
  complete
}
on 304 {
  display "304[get_cookie Char][args]"
  return
}
on 305 {
  display "305[get_cookie Char][args]"
  return
}
on 306 {
  display "306[get_cookie Char][args]"
  return
}
on 307 {
  display "307[get_cookie Char][args]"
  return
}
on 308 {
  display "308[get_cookie Char][args]"
  return
}
on 309 {
  display "309[get_cookie Char][args]"
  return
}
on 310 {
  display "310[get_cookie Char][args]"
  return
}
on 311 {display "[get_cookie Char](\002Whois\002) Whois results for [color nick][lindex [args] 1]" ; display "    [color nick][lindex [args] 1][color default] is [lindex [args] 2]@[lindex [args] 3] ([color nick][lindex [args] 5][color default])" ; complete}
on 312 {display "    on IRC via [lindex [args] 2] ([color nick][lindex [args] 3][color default])" ; complete}
on 313 {display "    [color nick][lindex [args] 1] [color default]IS an IRCop..." ; complete}
on 314 {display "[get_cookie Char](\002Whowas\002) Whowas results for [color nick][lindex [args] 1]" ; display "    [color nick][lindex [args] 1][color default] is [lindex [args] 2]@[lindex [args] 3] ([color nick][lindex [args] 5][color default])" ; complete}
on 315 {if {[get_cookie Update(IAL-[lindex [server] 0])] == 1} {if {[lsearch [raw_args] [lindex [channels] end]] != -1} {set_cookie Update(IAL-[lindex [server] 0]) 0 ; display "[get_cookie Char][color highlight]Internal Address List Updated..." ; complete} {complete} } ; complete}
on 316 {
  display "316[get_cookie Char][args]"
  return
}
on 317 {display "    [color nick][lindex [args] 1][color default] has been idle [color nick][elapsedtime [lindex [args] 2]][color default]" ; complete }
on 318 {complete}
on 319 {display "    on channels: [color nick][lindex [args] 2]" ; complete}
on 320 {
  display "320[get_cookie Char][args]"
  return
}
on 321 {display "[get_cookie Char][args]" ; complete}
on 322 {
  display "322[get_cookie Char][args]"
  return
}
on 323 {
  display "323[get_cookie Char][args]"
  return
}
on 324 {
  set chan [lindex [args] 1]
  if {[string trim [lindex [args] 2] +] != ""} {
    echo "[get_cookie Char]Modes for [color nick]$chan[color default] are [color ctcp]\"[lrange [args] 2 end]\"" channel [lindex [args] 1]
  } {
    set id [chanid [channel]]
    if {$id != -1} {
      set modes [lindex [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])] 0]
      if {[isop [my_nick] $chan]} {
        if {[string first : [lindex [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])] 0]] != -1} {
          /mode $chan [lrange [split [lindex [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])] 0] :] 0 end]
        } {
          /mode $chan $modes
        }
      }
    } elseif {[isop [my_nick] $chan] && $id == -1} {
      /mode $chan [join [get_cookie Channel(Modes-Defaults)]]
    }
  }
}
on 325 {
  display "325[get_cookie Char][args]"
  return
}
on 326 {
  display "326[get_cookie Char][args]"
  return
}
on 327 {
  display "327[get_cookie Char][args]"
  return
}
on 328 {
  display "328[get_cookie Char][args]"
  return
}
on 329 {echo "[get_cookie Char][color nick][lindex [args] 1][color default] was created on [color nick][clock format [lindex [args] 2] -format "%a %b %d %H:%M:%S %Y"]" channel [lindex [args] 1] ; complete}
on 330 {
  display "330[get_cookie Char][args]"
  return
}
on 331 {
  display "331[get_cookie Char][args]"
  return
}
on 332 {echo "[get_cookie Char]Topic for [color nick][lindex [args] 1][color default] is [color ctcp]\"[lindex [args] 2]\"" channel [lindex [args] 1] ; complete}
on 333 {
  echo "[color highlight][get_cookie Char]Topic set by [lindex [args] 2] on [clock format [lindex [args] 3]]." channel [lindex [args] 1]
  if {![llength [get_cookie Ticks([string trimleft [lindex [args] 1] #])]]} {
    set_cookie Ticks([string trimleft [lindex [args] 1] #]) [expr [clock clicks] - 300]
  }
  set timeon [expr [clock clicks] - [get_cookie Ticks([string trimleft [lindex [args] 1] #])]]
  if {[string length $timeon] > 3} {set timeon 0.[string range $timeon 0 2]} {set timeon 0.[join $timeon ""]}
  echo "[color highlight][get_cookie Char]Join synched in $timeon seconds." channel [lindex [args] 1]
  set_cookie Ticks([string trimleft [lindex [args] 1] #]) ""
  complete
}
on 334 {
  display "334[get_cookie Char][args]"
  return
}
on 335 {
  display "335[get_cookie Char][args]"
  return
}
on 336 {
  display "336[get_cookie Char][args]"
  return
}
on 337 {
  display "337[get_cookie Char][args]"
  return
}
on 338 {
  display "338[get_cookie Char][args]"
  return
}
on 339 {
  display "339[get_cookie Char][args]"
  return
}
on 340 {
  display "340[get_cookie Char][args]"
  return
}
on 341 {
  display "341[get_cookie Char][args]"
  return
}
on 342 {
  display "342[get_cookie Char][args]"
  return
}
on 343 {
  display "343[get_cookie Char][args]"
  return
}
on 344 {
  display "344[get_cookie Char][args]"
  return
}
on 345 {
  display "345[get_cookie Char][args]"
  return
}
on 346 {
  display "346[get_cookie Char][args]"
  return
}
on 347 {
  display "347[get_cookie Char][args]"
  return
}
on 348 {
  display "348[get_cookie Char][args]"
  return
}
on 349 {
  display "349[get_cookie Char][args]"
  return
}
on 350 {
  display "350[get_cookie Char][args]"
  return
}
on 351 {
  display "351[get_cookie Char][args]"
  return
}
on 352 {
  set nick [lindex [args] 5]
  set user [lindex [args] 2]
  set host [lindex [args] 3]
  if {[get_cookie Update(IAL-[lindex [server] 0])] == 0} {
    addresslist $nick $user $host
    display "[get_cookie Char](\002Who\002) Who results for [color nick][lindex [args] 5]"
    display "    [format "%-[string length [lindex [args] 1]]s %-9s %-[string length [lindex [args] 3]]s %-[string length [lindex [args] 4]]s %-14s %-5s %-4s %-0s" Channel Username Domain Server Nickname Stats Hops Realname]"
    display "    [format "%-[string length [lindex [args] 1]]s %-9s %-[string length [lindex [args] 3]]s %-[string length [lindex [args] 4]]s %-14s %-5s %-4s %-0s" [lindex [args] 1] [lindex [args] 2] [lindex [args] 3] [lindex [args] 4] [lindex [args] 5] [lindex [args] 6] [lindex [lindex [args] 7] 0] [lrange [lindex [args] 7] 1 end]]"
  }
  addresslist $nick $user $host
  complete
} 
on 353 {
  foreach cn [lindex [args] 3] {
    if {[string index $cn 0] == "@" || [string index $cn 0] == "+"} {lappend cl [color ctcp]$cn} {lappend cl [color nick]$cn}
    if {[llength $cl] == 7} {
      echo "  [format "%-15s %-15s %-15s %-15s %-15s %-15s %-15s" [lindex $cl 0] [lindex $cl 1] [lindex $cl 2] [lindex $cl 3] [lindex $cl 4] [lindex $cl 5] [lindex $cl 6]]" channel [lindex [args] 2] ; unset cl
    }
  }
  if {[info exists cl]} {
    echo "  [format "%-15s %-15s %-15s %-15s %-15s %-15s %-15s" [lindex $cl 0] [lindex $cl 1] [lindex $cl 2] [lindex $cl 3] [lindex $cl 4] [lindex $cl 5] [lindex $cl 6]]" channel [lindex [args] 2] ; unset cl
  }
  complete
}
on 354 {
  display "354[get_cookie Char][args]"
  return
}
on 355 {
  display "355[get_cookie Char][args]"
  return
}
on 356 {
  display "356[get_cookie Char][args]"
  return
}
on 357 {
  display "357[get_cookie Char][args]"
  return
}
on 358 {
  display "358[get_cookie Char][args]"
  return
}
on 359 {
  display "359[get_cookie Char][args]"
  return
}
on 360 {
  display "360[get_cookie Char][args]"
  return
}
on 361 {
  display "361[get_cookie Char][args]"
  return
}
on 362 {
  display "362[get_cookie Char][args]"
  return
}
on 363 {
  display "363[get_cookie Char][args]"
  return
}
on 364 {get_server [args] ; complete}
on 365 {
  display "365[get_cookie Char][args]"
  return
}
on 366 {
  set onick [llength [nicks [lindex [args] 1] @*]]
  set vnick [llength [nicks [lindex [args] 1] +*]]
  set total [llength [nicks [lindex [args] 1] *]]
  set nonick [expr $total - $onick]
  echo "[color highlight][get_cookie Char]Ministats : +o:$onick -o:$nonick +v:$vnick t:$total" channel [lindex [args] 1]
  set id [chanid [lindex [args] 1]]
  if {$id != -1} {echo "[get_cookie Char]Channel modes for [color nick]#[lindex [get_cookie Channel(Channels)] $id][color default] are [color nick]+[get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]" channel [lindex [args] 1]}
  complete
}
on 367 {
  if {![info exists banlist([string tolower [lindex [args] 0]])]} {set banlist([string tolower [lindex [args] 0]]) ""}
  lappend banlist([string tolower [lindex [args] 1]]) [lrange [args] 2 end]
  complete
}
on 368 {
  if {![info exists banlist([string tolower [lindex [args] 0]])]} {set banlist([string tolower [lindex [args] 0]]) ""}
  complete
}
on 369 {complete}
on 370 {
  display "370[get_cookie Char][args]"
  return
}
on 371 {
  display "371[get_cookie Char][args]"
  return
}
on 372 {
  display "372[get_cookie Char][args]"
  return
}
on 373 {
  display "373[get_cookie Char][args]"
  return
}
on 374 {
  display "374[get_cookie Char][args]"
  return
}
on 375 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 376 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 377 {display "[get_cookie Char][lindex [args] 1]" ; complete}
on 378 {
  display "378[get_cookie Char][args]"
  return
}
on 379 {
  display "379[get_cookie Char][args]"
  return
}
on 380 {
  display "380[get_cookie Char][args]"
  return
}
on 381 {
  display "381[get_cookie Char][args]"
  return
}
on 382 {
  display "382[get_cookie Char][args]"
  return
}
on 383 {
  display "383[get_cookie Char][args]"
  return
}
on 384 {
  display "384[get_cookie Char][args]"
  return
}
on 385 {
  display "385[get_cookie Char][args]"
  return
}
on 386 {
  display "386[get_cookie Char][args]"
  return
}
on 387 {
  display "387[get_cookie Char][args]"
  return
}
on 388 {
  display "388[get_cookie Char][args]"
  return
}
on 389 {
  display "389[get_cookie Char][args]"
  return
}
on 390 {
  display "390[get_cookie Char][args]"
  return
}
on 391 {
  if {[get_cookie Update(Links)]} {
    display "[get_cookie Char]Checking links for Update"
    set_cookie Update(Links) 0
    set servers [get_cookie Update(LinksList)]
    if {[isin [lindex [args] 1] $servers] && ![isin $IRCserver $servers]} {
      display "[get_cookie Char]Links Updating for $IRCserver"
      lappend servers $IRCserver
      set_cookie Update(LinksList) [join $servers]
    }
    autojoin
  }
  if {[get_cookie Toggle(LinkLooker)] == 1} {display "[get_cookie Char]Located [color nick]\002[lindex [args] 1]\002..."}
  if {[get_cookie Update(Links)] == 0 && [get_cookie Toggle(LinkLooker)] == 0} {display "[get_cookie Char][color nick][lindex [args] 1][color default] [lindex [args] 2]"}
  complete
}
on 392 {
  display "392[get_cookie Char][args]"
  return
}
on 393 {
  display "393[get_cookie Char][args]"
  return
}
on 394 {
  display "394[get_cookie Char][args]"
  return
}
on 395 {
  display "395[get_cookie Char][args]"
  return
}
on 396 {
  display "396[get_cookie Char][args]"
  return
}
on 397 {
  display "397[get_cookie Char][args]"
  return
}
on 398 {
  display "398[get_cookie Char][args]"
  return
}
on 399 {
  display "399[get_cookie Char][args]"
  return
}
on 400 {
  display "400[get_cookie Char][args]"
  return
}
on 401 {
  set nick [lindex [args] 1]
  set i [lsearch [get_cookie DNS(Nicks)] $nick]
  while {$i > -1} {set_cookie DNS(Nicks) [lreplace [get_cookie DNS(Nicks)] $i $i] ; set i [lsearch [get_cookie DNS(Nicks)] $nick]}
  if {[lindex [args] 1] == [get_cookie RegainNick(Nick)]} {/raw nick [get_cookie RegainNick(Nick)]} {
    display "[color highlight][get_cookie Char][lindex [args] 1]: No such nick/channel"
  }
  complete
}
on 402 {
  if {[get_cookie Toggle(LinkLooker)] == 1} {
    display "[color highlight]Detected possible split on \002[color nick][lindex [args] 1]\002"
  } {
    if {[get_cookie Update(Links)] == 1} {set_cookie Update(Links) 0} {display "[get_cookie Char][color nick][lindex [args] 1][color default] No such server"}
  }
  complete
}
on 403 {
  display "403[get_cookie Char][args]"
  return
}
on 404 {
  display "404[get_cookie Char][args]"
  return
}
on 405 {
  display "405[get_cookie Char][args]"
  return
}
on 406 {
  display "406[get_cookie Char][args]"
  return
}
on 407 {
  display "407[get_cookie Char][args]"
  return
}
on 408 {
  display "408[get_cookie Char][args]"
  return
}
on 409 {
  display "409[get_cookie Char][args]"
  return
}
on 410 {
  display "410[get_cookie Char][args]"
  return
}
on 411 {
  display "411[get_cookie Char][args]"
  return
}
on 412 {
  display "412[get_cookie Char][args]"
  return
}
on 413 {
  display "413[get_cookie Char][args]"
  return
}
on 414 {
  display "414[get_cookie Char][args]"
  return
}
on 415 {
  display "415[get_cookie Char][args]"
  return
}
on 416 {
  display "416[get_cookie Char][args]"
  return
}
on 417 {
  display "417[get_cookie Char][args]"
  return
}
on 418 {
  display "418[get_cookie Char][args]"
  return
}
on 419 {
  display "419[get_cookie Char][args]"
  return
}
on 420 {
  display "420[get_cookie Char][args]"
  return
}
on 421 {display "[get_cookie Char][lindex [args] 1] [lindex [args] 2]" ; complete}
on 422 {
  display "422[get_cookie Char][args]"
  return
}
on 423 {
  display "423[get_cookie Char][args]"
  return
}
on 424 {
  display "424[get_cookie Char][args]"
  return
}
on 425 {
  display "425[get_cookie Char][args]"
  return
}
on 426 {
  display "426[get_cookie Char][args]"
  return
}
on 427 {
  display "427[get_cookie Char][args]"
  return
}
on 428 {
  display "428[get_cookie Char][args]"
  return
}
on 429 {
  display "429[get_cookie Char][args]"
  return
}
on 430 {
  display "430[get_cookie Char][args]"
  return
}
on 431 {
  display "431[get_cookie Char][args]"
  return
}
on 432 {
  display "432[get_cookie Char][args]"
  return
}
on 433 {
  display "433[get_cookie Char][args]"
  return
}
on 434 {
  display "434[get_cookie Char][args]"
  return
}
on 435 {
  display "435[get_cookie Char][args]"
  return
}
on 436 {
  display "436[get_cookie Char][args]"
  return
}
on 437 {
  display "437[get_cookie Char][args]"
  return
}
on 438 {
  display "438[get_cookie Char][args]"
  return
}
on 439 {
  display "439[get_cookie Char][args]"
  return
}
on 440 {
  display "440[get_cookie Char][args]"
  return
}
on 441 {
  display "441[get_cookie Char][args]"
  return
}
on 442 {
  display "442[get_cookie Char][args]"
  return
}
on 443 {
  display "443[get_cookie Char][args]"
  return
}
on 444 {
  display "444[get_cookie Char][args]"
  return
}
on 445 {
  display "445[get_cookie Char][args]"
  return
}
on 446 {
  display "446[get_cookie Char][args]"
  return
}
on 447 {
  display "447[get_cookie Char][args]"
  return
}
on 448 {
  display "448[get_cookie Char][args]"
  return
}
on 449 {
  display "449[get_cookie Char][args]"
  return
}
on 450 {
  display "450[get_cookie Char][args]"
  return
}
