## Internal Help File
## This took alot of time to write, and as such may have
## a few errors in spelling, grammer or what have you. If
## in the event that you come across said errors, please
## report them so that I may correct in the future.

alias ihelp {
  switch [string tolower [lindex [args] 0]] {
    "addhost" {
      display "[color ctcp]Usage: /addhost <\002nickname\002> <\002hostmask\002>"
      display "  Adds a hostmask to a users record within the userlist. Hostmasks"
      display "  are used to identify the known users from users you dont know, as"
      display "  well as give some users certain access rights within channels."
      display "  See also, \002remhost\002"
    }
    "addshit" {
      display "[color ctcp]Usage: /addshit <\002address\002> \[\002chan chan chan\002\]"
      display "  Adds an address to internal shitlist with optional channel"
      display "  or channels to prevent access to"
      display "  See also, \002remshit\002"
    }
    "adduser" {
      display "[color ctcp]Usage: /adduser <\002nickname\002>"
      display "  Creates a new user record for a user on the channel the"
      display "  command was issued, using their current hostmask. If a"
      display "  user already exists with that nickname and their current"
      display "  hostmask is not know, then that users hostmask is added"
      display "  to the user record on file."
      display "  See also, \002remuser, addhost, remhost\002"
    }
    "ame" {
      display "[color ctcp]Usage: /ame <\002message\002>"
      display "  Send action to all channels."
    }
    "amsg" {
      display "[color ctcp]Usage: /amsg <\002message\002>"
      display "  Send msg to all channels."
    }
    "antiidle" {

    }
    "autojoin" {
      display "[color ctcp]Usage: /autojoin <\002on|off\002>"
      display "  Allows you to disable autojoin for all channels that have the autojoin"
      display "  feature enabled in channel records, without removing them all."
      display "  \002on\002 - turns autojoin on and joins all channels"
      display "  \002off\002 - turns autojoin off temporarily"
    }
    "away" {
      display "[color ctcp]Usage: /away"
      display "  Leave a message explaining that you are not currently paying attention"
      display "  to IRC. Whenever someone sends you a MSG or does a WHOIS on you, they"
      display "  automatically see whatever message you set. Using AWAY with no"
      display "  parameters marks you as no longer being away."
      display "  See also, \002saway, back\002"
    }
    "back" {
      display "[color ctcp]Usage: /back \[\002message\002\]"
      display "  Returns you to IRC making you nolonger away with optional return"
      display "  message displayed to all channels."
      display "  See also, \002away, saway\002"
    }
    "ban" {
      display "[color ctcp]Usage: /ban \[\002-rapu#\002\] <\002user\002>"
      display "  This bans someone from the current channel using their address. To do"
      display "  this, it first does a /getmask on the user, which gives it the user's"
      display "  address, and then it does a /mode # +b <user address>."
      display "  If you specify the -u# option then $version pauses # seconds before"
      display "  removing the ban."
      display " "
      display "  If you do not specify a ban type, then $version uses the whole"
      display "  nick!*user@host.domain to do the ban. If you are banning an IP address"
      display "  then a wild card replaces the last number of the IP address. If you"
      display "  are on the channel then the #channel specification is not necessary."
      display "  See also, \002bans, gb, gban\002"
    }
    "bans" {
      display "[color ctcp]Usage: /bans"
      display "  Shows list of current channel bans."
      display "  See also, \002ban\002"
    }
    "chat" {
      display "[color ctcp]Usage: /chat <\002user\002>"
      display "  Initiates a client to client connection with another user for quick."
      display "  near realtime conversation."
    }
    "chanmode" {
      display "[color ctcp]Usage: /chanmode \[\002add|rem|addkey|remkey\002\] \[\002channel\002\] \[\002mode|key\002\]"
      display "  Gives you the ability to set default modes for a particular channel."
      display "  as well as specify a key, or a user limit"
      display "  \002add\002 - adds channel modes to channel records"
      display "  \002rem\002 - removes channel modes from channel records"
      display "  \002addkey\002 - adds channel key to channel record"
      display "  \002remkey\002 - removes channel key from channel record"
      display " "
      display "  Example:"
      display "  #^TeStInG +nstkl testing 11 (with a key of 'testing' and a limit of '11')"
      display "  chanmode add #^TeStInG +nst"
      display "  chanmode addkey #^TeStInG +kl testing limit"
    }
    "chanrec" {
      display "[color ctcp]Usage: /chanrec \[\002add|rem\002\] \[\002channel\002\]"
      display "  Controls hilite features for messages entered by other users."
      display "  \002add\002 - adds new channel record"
      display "  \002rem\002 - removes existing channel record"
    }
    "chanstats" {
      display "[color ctcp]Usage: /chanstats <\002channel\002>"
      display "  Displays a summary or how many users are in the channel as well as"
      display "  how many have ops, voice or are regular users."
    }
    "chattr" {
      display "[color ctcp]Usage: /chattr <\002user\002> \[\002flags\002\] \[\002channel\002\]"
      display "  Allows you to view and change a users attributes (flags) both"
      display "  globally or channel specific. This gives a user more or less"
      display "  privledges within channels you reside in."
    }
    "chnick" {
      display "[color ctcp]Usage: /chnick <\002oldnick\002> <\002newnick\002>"
      display "  Allows you to change a known users nickname within the userlist."
      display "  This transfers all channel records and hostmasks of the old nickname"
      display "  to the new nickname."
    }
    "clonechk" {
      display "[color ctcp]Usage: /c-chk <\002channel\002>"
      display "  Check channel for clones, listing the quantiy as well as the clones."
    }
    "ctcpstats" {
      display "[color ctcp]Usage: /ctcpinfo"
      display "  Returns current CTCP information and stats."
    }
    "cycle" {
      display "[color ctcp]Usage: /cycle <\002channel\002>"
      display "  Cycles the channel, does a quick part and rejoin to gain ops"
      display "  in a opless channel."
      display "  See also, \002join, part\002"
    }
    "deop" {
      display "[color ctcp]Usage: /deop <\002user,user,user,etc\002>"
      display "  Will remove ops (+o) from the users you specify as long as you"
      display "  currently have ops in the channel the command was issued."
      display "  See also, \002op\002"
    }
    "describe" {
      display "[color ctcp]Usage: /describe <\002message\002>"
      display "  Will send your message to teh channel in a descriptive format,"
      display "  similar to an action."
      display "  See also, \002me\002"
    }
    "devoice" {
      display "[color ctcp]Usage: /devoice <\002user,user,user,etc\002>"
      display "  Will remove voice (+v) from the users you specify as long as you"
      display "  currently have ops in the channel the command was issued."
      display "  See also, \002voice\002"
    }
    "dns" {
      display "[color ctcp]Usage: /dns <\002nickname|domain\002>"
      display "  Returns numerical IP results for the specified user"
      display "  or domain."
    }
    "do" {
      display "[color ctcp]Usage: /do <\002user,user,user,etc\002>"
      display "  Will remove ops (+o) from the users you specify as long as you"
      display "  currently have ops in the channel the command was issued."
      display "  See also, \002op\002"
    }
    "dv" {
      display "[color ctcp]Usage: /dv <\002user,user,user,etc\002>"
      display "  Will remove voice (+v) from the users you specify as long as you"
      display "  currently have ops in the channel the command was issued."
      display "  See also, \002voice\002"
    }
    "find" {
      display "[color ctcp]Usage: /find \[\002filename\002\]"
      display "  Locates a filename within the current system paths displaying"
      display "  the location if found."
    }
    "fk" {
      display "[color ctcp]Usage: /fk \[\002arg\002\]"
      display "  Kicks users in channel, if address contains \[arg\]."
      display "  See also, \002kick\002"
    }
    "fwall" {
      display "[color ctcp]Usage: /fwall <\002message\002>"
      display "  Sends the current channel a notice that only channel operators"
      display "  can see, does not require you to have ops in the channel, but"
      display "  will usually result in your removal from the channel by being"
      display "  kicked or kicked and banned."
    }
    "fwo" {
      display "[color ctcp]Usage: /fwo <\002message\002>"
      display "  Sends the current channel a notice that only channel operators"
      display "  can see, does not require you to have ops in the channel, but"
      display "  will usually result in your removal from the channel by being"
      display "  kicked or kicked and banned."
      display "  See also, \002fwall\002"
    }
    "gb" {
      display "[color ctcp]Usage: /gb <\002arg\002>"
      display "  Bans an address in channel that contains arg."
      display "  ie: aol (*!*@*.aol.*) netcom (*!*@*.netcom.*)"
      display "  See also, \002ban, kickban, kb, tkb, gban\002"
    }
    "gban" {
      display "[color ctcp]Usage: /gban <\002arg\002>"
      display "  Bans an address in channel that contains arg."
      display "  ie: aol (*!*@*.aol.*) netcom (*!*@*.netcom.*)"
      display "  See also, \002ban, kickban, kb, tkb, gb\002"
    }
    "hilite" {
      display "[color ctcp]Usage: /hilite \[\002on|off|add|rem\002\] \[\002word\002\]"
      display "  Controls hilite features for messages entered by other users."
      display "  \002on\002 - enables hiliteing for special words"
      display "  \002off\002 - disables hiliteing for special words"
      display "  \002add\002 - adds a word to your hilite list"
      display "  \002rem\002 - removes a word from your hilite list"
    }
    "ignore" {
      display "[color ctcp]Usage: /ignore \[\002-rapcqniu#\002\] <\002user\002>"
      display "  Ignore the messages from various users or addresses."
      display "  The following applies when included with -\[apcqni\]"
      display "    \002a\002  ignores all incoming messages from all types"
      display "    \002c\002  ignores all incoming ctcp's"
      display "    \002q\002  ignores all incoming queries"
      display "    \002p\002  ignores all incoming public channel talk"
      display "    \002n\002  ignores all incoming notices"
      display "    \002i\002  ignores all incoming invite requests."
      display "    u\002#\002 specifies a delay in seconds after which the ignore is"
      display "       automatically removed."
      display "    \002r\002  indicates that the address is to be removed."
      display " "
      display "  Ignore will lookup a users address if its not in the addresslist"
      display "  and ignore them. If no variable is supplie, then the default ignore"
      display "  for that hostmask is -a."
      display "  See also, \002ignores\002"
    }
    "ignores" {
      display "[color ctcp]Usage: /ignores"
      display "  Shows a list of current ignores seperated by which type of ignore"
      display "  it is with the following headers:"
      display "    \002ALL\002     ignores all incoming messages from all types"
      display "    \002CTCP\002   ignores all incoming ctcp's"
      display "    \002QUERY\002   ignores all private messages"
      display "    \002PUBLIC\002 ignores all public channel talk"
      display "    \002NOTICE\002 ignores all notices"
      display "    \002INVITE\002 ignores all channel invite requests"
      display " "
      display "  a hostmask of type '*!*@*' is usually set by flood protection"
      display "  and will ignore all incoming ctcp's, messages, notices, etc.."
      display "  all other types are user specific."
      display "  See also, \002ignore\002"
    }
    "istats" {
      display "[color ctcp]Usage: /istats"
      display "  Displays current settings for various internal toggles, stats"
      display "  consists of: autojoin, lastseen, notify, regain nick, split detect,"
      display "  text hilite and away status."
    }
    "iwhois" {
      display "[color ctcp]Usage: /iwhois <\002nickname\002>"
      display "  Shows the current user record information of a user within"
      display "  the userlist with the following headers:"
      display "    NICK  the nickname of the user whos user record is shown"
      display "    PASS  yes/no if she/he has a password set"
      display "    FLAGS  list of global attributes (flags) set for the user"
      display " "
      display "  valid global attributes (flags) are as follows:"
      display "    \002o\002  global op (user is a valid op on any channel)"
      display "    \002d\002  global deop (user is deopted on all channels)"
      display "    \002k\002  global kick (user is kicked from all channels)"
      display "    \002b\002  global ban (user is banned from all channels)"
      display "    \002f\002  global friend (user is not punished for doing things)"
      display "    \002p\002  global protect (user is protected from kicks and bans)"
      display "    \002v\002  global voice (user is givin +v on channels with autovoice)"
      display "    \002a\002  global kick (user is given +o on channels with autoop)"
      display " "
      display "  each channel the user has access to will have a seperate"
      display "  channel record for that channel as well as channel specific"
      display "  attributes (flags)."
      display "  valid channel attributes (flags) are as follows:"
      display "    \002o\002  op (user is a valid op on channel)"
      display "    \002d\002  deop (user is deopted on channel)"
      display "    \002k\002  kick (user is kicked from channel)"
      display "    \002b\002  ban (user is banned from channel)"
      display "    \002f\002  friend (user is not punished for doing things)"
      display "    \002p\002  protect (user is protected from kicks and bans)"
      display "    \002v\002  voice (user is givin +v on channel with autovoice)"
      display "    \002a\002  kick (user is given +o on channel with autoop)"
      display " "
      display "  hostmasks for the specified user are displayed last, a user can"
      display "  have any number of hostmasks, its up to you to control how many"
      display "  you think are valid."
    }
    "j" {
      display "[color ctcp]Usage: /j <\002channel\002>"
      display "  Joins a channel on irc if you are currently not on it."
      display "  See also, \002part\002"
    }
    "join" {
      display "[color ctcp]Usage: /join <\002channel\002>"
      display "  Joins a channel on irc if you are currently not on it."
      display "  See also, \002part\002"
    }
    "k" {
      display "[color ctcp]Usage: /k <\002user,user,user,etc\002> \[\002message\002\]"
      display "  This kicks users from the current channel with an optional message."
      display "  See also, \002kick\002"
    }
    "kb" {
      display "[color ctcp]Usage: /kb <\002user,user,user,etc\002> \[\002message\002\]"
      display "  Kicks and bans users from the current channel with an optional"
      display "  message."
      display "  See also, \002ban, kickban, gb, gban, tkb\002"
    }
    "kbi" {
      display "[color ctcp]Usage: /kbi <\002user,user,user,etc\002> \[\002message\002\]"
      display "  Kicks and bans users from the current channel, as well as"
      display "  places the user on ignore with an optional message."
      display "  See also, \002ban, kickban, gb, gban, tkb\002"
    }
    "kick" {
      display "[color ctcp]Usage: /kick <\002user,user,user,etc\002> \[\002message\002\]"
      display "  This kicks users from the current channel with an optional message."
      display "  See also, \002k\002"
    }
    "kickall" {
      display "[color ctcp]Usage: /kickall \[\002user user user\002\]"
      display "  Kickall users in channel, if no users are specified, kickall"
      display "  performs on current channel."
      display "  See also, \002kick, kicknops, kicknvoc, kickops\002"
    }
    "kickban" {
      display "[color ctcp]Usage: /kickban <\002user,user,user,etc\002> \[\002message\002\]"
      display "  Kicks and bans users from the current channel with an optional."
      display "  message."
      display "  See also, \002ban, kb, gb, gban, tkb\002"
    }
    "kickno" {
      display "[color ctcp]Usage: /kickno \[\002user user user\002\]"
      display "  Kick nonop users in channel, if no users are specified, kickno"
      display "  performs on current channel."
      display "  See also, \002kick, kickall, kicknv, kicko, kickv\002"
    }
    "kicknv" {
      display "[color ctcp]Usage: /kicknv \[\002user user user\002\]"
      display "  Kick nonop/voc users in channel, if no users are specified, kicknv"
      display "  performs on current channel."
      display "  See also, \002kick, kickall, kickno, kicko, kickv\002"
    }
    "kicko" {
      display "[color ctcp]Usage: /kicko \[\002user user user\002\]"
      display "  Kick op users in channel, if no users are specified, kicko"
      display "  performs on current channel."
      display "  See also, \002kick, kickall, kickno, kicknv, kickv\002"
    }
    "kickv" {
      display "[color ctcp]Usage: /kickv \[\002user user user\002\]"
      display "  Kick voiced users in channel, if no users are specified, kickv"
      display "  performs on current channel."
      display "  See also, \002kick, kickall, kickno, kicknv, kicko\002"
    }
    "killtimer" {
      display "[color ctcp]Usage: /killtimer <\002timerID\002>"
      display "  This deactivates a specified timer and prevents it from performing""
      display "  its specified command."
      display "  Example:"
      display "  for deactivating \{3 sayhello after#1332\} type \002/killtimer 1332\002"
      display "  See also, \002timer, utimer, killutimer\002"
    }
    "killutimer" {
      display "[color ctcp]Usage: /killutimer <\002utimerID\002>"
      display "  This deactivates a specified timer and prevents it from performing""
      display "  its specified command."
      display "  Example:"
      display "  for deactivating \{3 sayhello after#1332\} is \002/killutimer 1332\002"
      display "  See also, \002timer, utimer, killtimer\002"
    }
    "leet" {

    }
    "leetkickban" {

    }
    "listopers" {
      display "[color ctcp]Usage: /listopers <\002channel\002>"
      display "  Lists IRCops on current or specified channel."
    }
    "lk" {

    }
    "lkb" {

    }
    "lkbi" {

    }
    "ll" {
      display "[color ctcp]Usage: /ll \[\002on|off\002\]"
      display "  Activates internal linklooker"
      display "  \002on\002 - enables linklooker for detecting splits"
      display "  \002off\002 - disables linklooker"
    }
    "longip" {
      display "[color ctcp]Usage: /longip <\002dns\002>"
      display "  Returns LONGIP results for specified address."
    }
    "m" {
      display "[color ctcp]Usage: /m <\002nick\002>"
      display "  Sends a private msg to someone on irc, if they are not"
      display "  connected, then an error message is returned."
    }
    "mass+o" {
      display "[color ctcp]Usage: /mass+o \[\002user user user\002\]"
      display "  Massops users in channel by quantities of 4 (+oooo),"
      display "  if no users are specified, massop performs on current"
      display "  channel."
      display "  See also, \002op\002"
    }
    "mass+v" {
      display "[color ctcp]Usage: /mass+v \[\002user user user\002\]"
      display "  Massvoice users in channel by quantities of 4 (+vvvv),"
      display "  if no users are specified, massvoice performs on current"
      display "  channel."
      display "  See also, \002voice\002"
    }
    "mass-o" {
      display "[color ctcp]Usage: /mass-o \[\002user user user\002\]"
      display "  Massdeops users in channel by quantities of 4 (-oooo),"
      display "  if no users are specified, massdeop performs on current"
      display "  channel."
      display "  See also, \002deop\002"
    }
    "mass-v" {
      display "[color ctcp]Usage: /mass-v \[\002user user user\002\]"
      display "  Massdevoice users in channel by quantities of 4 (-vvvv),"
      display "  if no users are specified, massdevoice performs on current"
      display "  channel."
      display "  See also, \002devoice\002"
    }
    "match" {
      display "[color ctcp]Usage: /match \[\002flag|channel\002\] \[\002limit\002\]"
      display "  Finds matches within userlist for flags or channels. To specify"
      display "  more then the default limit of matches to be displayed, supply a"
      display "  limit after the match being requested."
    }
    "mi" {

    }
    "msgs" {
      display "[color ctcp]Usage: /msgs \[\002read|erase\002\]"
      display "  Displays how many messages you have saved."
      display "  \002read\002 - displays all messages within message queue."
      display "  \002erase\002 - erases all messages within message queue."
      display "  See also, \002away\002"
    }
    "notify" {
      display "[color ctcp]Usage: /notify \[\002on|off|add|rem\002\] \[\002user\002\]"
      display "  Adds a users nickname to internal notify list."
      display "  \002on\002 - enables notify for your IRC session"
      display "  \002off\002 - disables notify for your IRC session"
      display "  \002add\002 - adds a nickname to your notify list"
      display "  \002rem\002 - removes a nickname from your notify list"
      display "  \002whosin\002 - shows users in notify list"
      display "  \002whoson\002 - shows users currently on IRC"
    }
    "o" {
      display "[color ctcp]Usage: /o <\002user,user,user,etc\002>"
      display "  Gives ops (+o) to a user or users on a channel as long"
      display "  as you have ops in that channel."
      display "  See also, \002deop\002"
    }
    "op" {
      display "[color ctcp]Usage: /op <\002user,user,user,etc\002>"
      display "  Gives ops (+o) to a user or users on a channel as long"
      display "  as you have ops in that channel."
      display "  See also, \002deop\002"
    }
    "p" {
      display "[color ctcp]Usage: /p <\002channel\002>"
      display "  Parts a channel on irc."
    }
    "part" {
      display "[color ctcp]Usage: /part <\002channel\002>"
      display "  Parts a channel on irc."
    }
    "ping" {
      display "[color ctcp]Usage: /ping <\002user\002> \[\002channel\002\]"
      display "  Send CTCP ping to user or channel."
    }
    "privmode" {
      display "[color ctcp]Usage: /privmode <\002add|rem\002> \[\002modes\002\]"
      display "  Adds or removes your personal irc modes to be set on connect."
      display "  \002add\002 - adds a new mode"
      display "  \002rem\002 - removes an existing mode"
      display " "
      display "  current modes consist of 'iwskr' as well as 'o' (for opers)"
    }
    "quit" {

    }
    "regain" {
      display "[color ctcp]Usage: /keepnick \[\002on|off\002\]"
      display "  Proceeds to keep nickname whenever different from default"
      display "  \002on\002 - enables regain nick for your IRC sessions"
      display "  \002off\002 - disables regain nick for your IRC sessions"
    }
    "reload" {
      display "[color ctcp]Usage: /reload"
      display "  Reloads the userfile discarding any changes made since the last"
      display "  hourly or manual save."
      display "  See also, \002save\002"
    }
    "remhost" {
      display "[color ctcp]Usage: /remhost <\002nickname\002> <\002hostmask\002>"
      display "  Removes a hostmask from a users record within the userlist. Hostmasks"
      display "  are used to identify the known users from users you dont know, as"
      display "  well as give some users certain access rights within channels."
      display "  See also, \002addhost\002"
    }
    "remshit" {
      display "[color ctcp]Usage: /remshit <\002address\002> \[\002chan chan chan\002\]"
      display "  Removes an address from internal shitlist with optional channel"
      display "  or channels to prevent access to."
      display "  See also, \002addshit\002"
    }
    "remuser" {
      display "[color ctcp]Usage: /remuser <\002nickname\002>"
      display "  Removes a user record for the nickname specified within the"
      display "  userlist, as well as all hostmasks and channel records for"
      display "  that user."
      display "  See also, \002adduser, addhost, remhost\002"
    }
    "save" {
      display "[color ctcp]Usage: /save"
      display "  Saves the userlist to '[get_cookie DatFile(UserList)]' on the harddrive."
      display "  This is useful in the event that you make changes to the userfile and"
      display "  feel that your system may hang or your connection be broken before the"
      display "  hourly save has a chance to perform."
      display "  See also, \002reload\002"
    }
    "saway" {

    }
    "scripts" {
      display "[color ctcp]Usage: /scripts"
      display "  List all scripts currently loaded."
    }
    "seen" {
      display "[color ctcp]Usage: /seen \[\002on|off|nick\002\]"
      display "  Keeps track of when users were lastseen within IRC channels"
      display "  \002on\002 - enables lastseen for your IRC sessions"
      display "  \002off\002 - disables lastseen for your IRC sessions"
      display "  \002nick\002 - searches for the last time nick was seen"
    }
    "setup" {

    }
    "sound" {

    }
    "splitchk" {
      display "[color ctcp]Usage: /splitchk \[\002on|off\002\]"
      display "  Performs checks for splits when users inadvertently quit IRC."
      display "  \002on\002 - enables splitchk capabilities during quits"
      display "  \002off\002 - disables splitchk capabilities"
    }
    "tcl" {

    }
    "telnet" {

    }
    "timer" {
      display "[color ctcp]Usage: /timer <\002minutes\002> <\002command\002>"
      display "  This activates a specified timer to perform a specified command at a"
      display "  specified time. To make your command repeat, put a similar timer"
      display "  within the command itself,"
      display "  Example:"
      display "  \002proc sayhello \{\} \{/msg \[channel\] hello \; /timer 3 sayhello\}\002"
      display "  See also, \002utimer, killtimer, killutimer\002"
    }
    "timers" {
      display "[color ctcp]Usage: /timers"
      display "  This displays a list of all currently active timers."
      display "  Example:"
      display "  \002\{3 sayhello after#1332\}\002"
      display "  See also, \002utimers\002"
    }
    "tkb" {
      display "[color ctcp]Usage: /tkb <\002user\002> \[\002message\002\]"
      display "  Kicks and bans someone temporarily from the current channel."
      display "  See also, \002ban, kb, gb, gban, kickban\002"
    }
    "topic" {
      display "[color ctcp]Usage: /topic \[topic\]"
      display "  Allows you to set a new topic for the current channel window."
      display "  If no topic is supplied, then the current topic for that channel"
      display "  is displayed."
    }
    "utimer" {
      display "[color ctcp]Usage: /utimer <\002seconds\002> <\002command\002>"
      display "  This activates a specified timer to perform a specified command at a"
      display "  specified time. To make your command repeat, put a similar timer"
      display "  within the command itself,"
      display "  Example:"
      display "  \002proc sayhello \{\} \{/msg \[channel\] hello \; /utimer 30 sayhello\}\002"
      display "  See also, \002timer, killtimer, killutimer\002"
    }
    "utimers" {
      display "[color ctcp]Usage: /timers"
      display "  This displays a list of all currently active utimers."
      display "  Example:"
      display "  \002\{30 sayhello after#1332\}\002"
      display "  See also, \002timers\002"
    }
    "v" {
      display "[color ctcp]Usage: /v <\002user,user,user,etc\002>"
      display "  Gives voice (+v) to a user or users on a channel as long"
      display "  as you have ops in that channel."
      display "  See also, \002devoice\002"
    }
    "viewfile" {

    }
    "viewlog" {

    }
    "voice" {
      display "[color ctcp]Usage: /voice <\002user,user,user,etc\002>"
      display "  Gives voice (+v) to a user or users on a channel as long"
      display "  as you have ops in that channel."
      display "  See also, \002devoice\002"
    }
    "w" {
      display "[color ctcp]Usage: /w <\002message\002>"
      display "  Sends the current channel a notice that only channel operators"
      display "  can see as long as you have ops in that channel."
    }
    "wall" {
      display "[color ctcp]Usage: /wall <\002message\002>"
      display "  Sends the current channel a notice that only channel operators"
      display "  can see as long as you have ops in that channel."
    }
    "whos" {
      display "[color ctcp]Usage: /whos \[nick\]"
      display "  Displays users address within internal addresslist."
    }
    "whosshit" {
      display "[color ctcp]Usage: /whoson"
      display "  Display addresses currently entered in shitlist."
      display "  See also, \002addshit, remshit\002"
    }
    "wordkick" {
      display "[color ctcp]Usage: /wordkick \[\002on|off|add|rem\002\] \[\002word\002\]"
      display "  Adds words to wordkick list, to prevent users from saying certain things."
      display "  \002add\002 - adds a word to your wordkick list"
      display "  \002rem\002 - removes a word from your wordkick list"
    }
    default {
      display "[color ctcp]*** Internal help documentation for $version"
      display "[color ctcp]  \002ascent\002 (e-snt') n. \0021.\002 The act of moving upward : to climb.  \0022.\002 An upward slope. \0023.\002 The act of rising above all others."
      display "  Commands:"
      foreach hw [get_cookie Help(Words)] {
        lappend hl [string toupper $hw]
        if {[llength $hl] == 7} {
          display "  [format "%-12s %-12s %-12s %-12s %-12s %-12s %-12s" [lindex $hl 0] [lindex $hl 1] [lindex $hl 2] [lindex $hl 3] [lindex $hl 4] [lindex $hl 5] [lindex $hl 6]]" ; unset hl
        }
      }
      if {[info exists hl]} {
        display "  [format "%-12s %-12s %-12s %-12s %-12s %-12s %-12s" [lindex $hl 0] [lindex $hl 1] [lindex $hl 2] [lindex $hl 3] [lindex $hl 4] [lindex $hl 5] [lindex $hl 6]]" ; unset hl
      }
      display "[color ctcp]  All commands begin with '/' and anything else is sent through irc."
      display "[color ctcp]  You can get help on an individual command by typing:"
      display "[color ctcp]      /ihelp <\002command\002>"
      display "[color ctcp]  arguments within \002< >\002 are required, all arguments in \002\[ \]\002 are"
      display "[color ctcp]  optional. additional help on irc can be found by typing:"
      display "[color ctcp]      /help"
      display " "
    }
  }
  complete
}
