proc gdl {} {return [get_cookie Directory(Logs)]/}
proc gdd {} {return [get_cookie Directory(XDCC)]\\}
proc gdw {} {return [get_cookie Directory(Waves)]/}
proc gdx {} {return [get_cookie Directory(XiRCON)]/}
proc gdj {} {return [get_cookie Directory(Journals)]/}
proc gds {} {global version ; return [get_cookie Directory($version)]/}
proc rand {args} {return [expr [random 1 $args] - 1]}
proc time {} {return [clock format [clock seconds] -format "%a %b %d %H:%M:%S"]}
proc convtime {time} {return [clock format $time -format "%b %d, %Y %H:%M:%S%p"]}
proc isop {nick chan} {foreach o [nicks $chan @*] {if {[string trimleft [string tolower $o] +@] == [string tolower $nick]} {return 1} } ; return 0}
proc isvoc {nick chan} {foreach v [nicks $chan +*] {if {[string trimleft [string tolower $v] +@] == [string tolower $nick]} {return 1} } ; return 0}
proc ison {nick chan} {foreach u [nicks $chan] {if {[string trimleft [string tolower $u] +@] == [string tolower $nick]} {return 1} } ; return 0}
proc isin {part group} {if {[lsearch [string tolower $group] [string tolower $part]] != -1} {return 1} ; return 0}
proc isnum {args} {if {[string trim $args 1234567890] == ""} {return 1} ; return 0}
proc readfile {file} {set id [open $file r] ; addsocket $id ; while {![eof $id]} {lappend contents "[gets $id]"} ; close $id ; killsocket $id ; return $contents}
proc savefile {file args} {set id [open $file w] ; addsocket $id ; puts -nonewline $id [join $args \n] ; close $id ; killsocket $id}
proc add2file {file args} {set id [open $file a+] ; addsocket $id ; puts $id [join $args] ; close $id ; killsocket $id}
proc makefile {file} {set id [open $file w] ; addsocket $id ; close $id ; killsocket $id}
proc fread {file} {set id [open $file r] ; addsocket $id ; while {![eof $id]} {set entry [gets $id] ; lappend file_list "$entry"} ; close $id ; killsocket $id ; set line [lindex $file_list [rand [llength $file_list]]] ; return $line}
proc fplay {cmd file} {set id [open $file r] ; addsocket $id ; while {![eof $id]} {set entry [ch4spec [gets $id]] ; switch [string tolower $cmd] {"me" {display "[join $entry]"} ; default {/msg $cmd [join $entry]} } } ; close $id ; killsocket $id}
proc nc {part} {foreach n [nicks [channel]] {if {[string tolower $part] == [string tolower [string range [string trimleft $n @+] 0 [expr [string length $part] - 1]]]} {return [string trimleft $n @+]} } ; return}
proc ncw {part parms} {foreach n $parms {if {[string tolower $part] == [string tolower [string range [string trimleft $n @+] 0 [expr [string length $part] - 1]]]} {return [string trimleft $n @+]} } ; return}
proc fid {args} {set id [lsearch [string tolower [lindex $args 0]] [string tolower [lindex $args 1]]] ; return $id}
proc chanid {args} {set id [lsearch [string tolower [get_cookie Channel(Channels)]] [string trimleft [string tolower $args] #]] ; return $id}
proc addsocket {args} {global socket ; set socket($args) [expr [clock seconds] + 5]}
proc chksocket {} {global socket ; foreach soc [array names socket] {if {[clock seconds] >= $socket($soc)} {close $soc ; killsocket $soc ; display "[get_cookie Char]Killing socket $soc"} } }
proc killsocket {args} {global socket ; unset socket($args)}
proc autojoin {} {
  if {[get_cookie Toggle(AutoJoin)] == 1} {
    foreach chan [get_cookie Channel(Channels)] {
      if {[string first autojoin [get_cookie ChannelSettings($chan)]] != -1 && ![isin $chan [channels]]} {
        /join #$chan [lindex [split [lindex [get_cookie ChannelSettings($chan)] 0] :] 1]
      }
    }
  }
}
proc add_carbon {nick args} {
  global carbon
  if {![info exists carbon($nick)]} {
    set carbon($nick) ""
    lappend carbon($nick) [join $args]
  } elseif {[llength $carbon($nick)] > 5} {
    set carbon($nick) [lreplace $carbon($nick) 0 0]
    lappend carbon($nick) [join $args]
  } {
    lappend carbon($nick) [join $args]
  }
}
proc find_file {filename} {
  set filename [file tail $filename]
  if {[file exists [pwd]/$filename]} {
    regsub -all {/} [pwd]/$filename {\\} filename
    return $filename
  }
  set dirs [glob -nocomplain [pwd]/*/]
  foreach dir $dirs {
    if {[file exists $dir$filename]} {
      regsub -all {/} $dir$filename {\\} filename
      return $filename
    }
  }
  return ""
}
proc quit {args} {
  set_cookie DCCS($args) ""
  set_cookie Queries($args) ""
  set_cookie Quitting($args) ""
  set_cookie Connection($args) ""
  set_cookie Notify(ISON-$args) ""
  set_cookie Update(IAL-$args) ""
  set_cookie Toggle(Notify-Go) ""
  set_cookie Toggle(IAL-$args) ""
  set_cookie Toggle(Away-$args) ""
  if {[get_cookie IRCserver] == $args} {set_cookie IRCserver ""}
}
proc connect {args} {
  if {[get_cookie IRCserver] == ""} {set_cookie IRCserver $args}
  if {[get_cookie Update(ServerList)] == 1} {/links ; after 10000 write_serverlist ; status_page 0 ; set_cookie Update(ServerList) ""}
  if {[get_cookie Update(LinksList)] == ""} {set_cookie Update(LinksList) [lindex [server] 0]}
  set_cookie Toggle(IAL-$args) [get_cookie Toggle(IAL)]
  set_cookie Toggle(Away-$args) 0
}
proc elapsedtime {total} {
  set time ""
  set hr [string trimright [expr $total / 3600] .]
  set min [string trimright [expr [expr $total - [expr $hr * 3600]] / 60] .]
  set sec [expr [expr $total - [expr $hr * 3600]] - [expr $min * 60]]
  if {$total >= 3600} {lappend time "$hr hours"}
  if {$total >= 60} {lappend time "$min minutes"}
  lappend time "$sec seconds"
  return [join $time]
}
proc addoperkill {oper} {
  set operkilllist [join [get_cookie OperKill(.list)]]
  if {[get_cookie OperKill($oper)] == ""} {set opercnt 1} {set opercnt [expr 1 + [get_cookie OperKill($oper)]]}
  set_cookie OperKill($oper) $opercnt
  if {[isin $oper [get_cookie OperKill(.list)]]} {
    lappend operkilllist [lindex [raw_args] 10] ; set_cookie OperKill(.list) [join $operkilllist]
  }
}
proc matchignore {type mask} {
  for {set i 0} {$i < [llength [get_cookie Ignore($type)]]} {incr i} {
    if {[string match [lindex [get_cookie Ignore($type)] $i] $mask]} {return 1}
  }
  return 0
}
proc icps {} {
  global ashift ashift_cnt ashift_max ashift_lvl
  if {$ashift_cnt < 0} {set ashift_cnt "0"}
  if {$ashift == "on"} {
    incr ashift_cnt
    after 12000 ashift_chk
    if {$ashift_cnt >= $ashift_max} {
      set ashift_cnt "0"
      if {$ashift_lvl == "Major"} {set ashift_lvl "Extreme" ; autoshift4}
      if {$ashift_lvl == "Medium"} {set ashift_lvl "Major" ; autoshift3}
      if {$ashift_lvl == "Minor"} {set ashift_lvl "Medium" ; autoshift2}
      display "[color highlight][get_cookie Char]Internal Protection Activated - (\002$ashift_lvl\002)"
      logevent personal "[nick] ([user]@[host]) Triggered Internal CTCP Protection System"
    }
  }
}
proc ashift_chk {} {
  global ashift_cnt
  if {$ashift_cnt > 0} {incr ashift_cnt -1 ; after 12000 ashift_chk}
  if {$ashift_cnt < 0} {set ashift_cnt 0 ; break}
}
proc autoshift1 {} {global ashift_lvl ; set ashift_lvl "Minor" ; /ignore -r *!*@* ; complete}
proc autoshift2 {} {global ashift_lvl ; set ashift_lvl "Medium" ; /ignore -c *!*@* ; /ignore -q *!*@* ; after 600000 autoshift1}
proc autoshift3 {} {global ashift_lvl ; set ashift_lvl "Major" ; /ignore -c *!*@* ; /ignore -q *!*@* ; after 300000 autoshift2}
proc autoshift4 {} {global ashift_lvl ; set ashift_lvl "Extreme" ; /ignore -r *!*@* ; /ignore -a *!*@* ; after 60000 autoshift3}
proc display {args} {if {[get_cookie Display(Output)] && [llength [channels]] > 0} {echo "[join $args]" channel [get_cookie ChannelWindow]} {echo "[join $args]" status} }
proc logmsgs {nick uhost args} {
  global awayMsgs
  set time [clock seconds]
  set msg [join [chk4spec [lrange $args 0 end]]]
  set n [llength [array names awayMsgs]]
  /raw notice [nick] :Thank you, Your message/page has been received.
  if {[string tolower [get_cookie Away(recorder)]] == "on"} {
    if [array exists awayMsgs] {set awayMsgs($n) "$time $nick $uhost $msg"} {set awayMsgs(0) "$time $nick $uhost $msg"}
  }
  if {[string tolower [get_cookie Away(pager)]] == "on"} {
    set_cookie Pager(Type) 1
    if {$msg == ""} {set msg "No msg sent."}
    display "[color highlight][get_cookie Char]You have been paged, Press <F11> to reset pager"
    if [array exists awayMsgs] {set awayMsgs($n) "$time $nick $uhost $msg"} {set awayMsgs(0) "$time $nick $uhost $msg"}
  }
  complete
}
proc logevent {type args} {
  if {![file isdirectory [gdj]]} {file mkdir [gdj]}
  if {[string first $type [get_cookie SpecialEventLogs]] != -1} {
    if {![file exists [gdj]$type.log]} {
      makefile [gdj]$type.log
    }
    set time "[convtime [clock seconds]]"
    add2file [gdj]$type.log [join ($time)] [join $args]
    return 1
  }
  return 0
}
proc cntmsgs {} {global awayMsgs ; set n 0 ; set t [array names awayMsgs] ; foreach no $t {incr n} ; return $n}
proc pager {} {
  if {[get_cookie Pager(Type)] == 1} {
    set pagersnd [get_cookie Pager(Sound)]
    if {$pagersnd == ""} {set pagersnd 0}
    if {$pagersnd == 3} {
      mmplay [gds][get_cookie Away(sound)]
      set pagersnd 0
    } {
      incr pagersnd
    }
    set_cookie Pager(Sound) $pagersnd
    set pagercount [get_cookie Pager(Count)]
    if {$pagercount == ""} {set pagercount 0}
    if {$pagercount == 30} {set_cookie Pager(Type) 2} {incr pagercount}
    set_cookie Pager(Count) $pagercount
  } elseif {[get_cookie Pager(Type)] == 2} {
    set pagerbeep [get_cookie Pager(Beep)]
    if {$pagerbeep == ""} {set pagerbeep 0}
    if {$pagerbeep == 90} {
      beep
      display "[color highlight][get_cookie Char]You have been paged, Press <F11> to reset pager"
      set pagerbeep 0
    } {
      incr pagerbeep
    }
    set_cookie Pager(Beep) $pagerbeep
  }
}
proc pagerreset {} {
  set_cookie Pager(Type) ""
  set_cookie Pager(Beep) ""
  set_cookie Pager(Sound) ""
  set_cookie Pager(Count) ""
}
proc wordkick_chk {nick chan args} {
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] $chan]} {
    if {[string first wordcheck [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![isop $nick $chan] && ![isvoc $nick $chan]} {
        foreach kw [get_cookie Channel(WordKicks)] {
          if {[string first $kw [join $args]] != -1} {/raw kick $chan $nick :\002AWK\002: $kw ; break}
        }
      }
    }
  }
}
proc textrepeat_chk {nick chan args} {
  global repeatlist
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] $chan]} {
    if {[string first repeat [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![isop $nick $chan] && ![isvoc $nick $chan]} {
        if {![info exists repeatlist([string tolower $nick])]} {
          set repeatlist([string tolower $nick]) [join $args]
        } elseif {[string match $repeatlist([string tolower $nick]) [join $args]]} {
          if {[llength $args] >= [get_cookie Channel(RepeatAmmt)]]} {/raw kick $chan $nick :\002Don't Repeat Yourself Stupid\002 ; break}
        } {
          set repeatlist([string tolower $nick]) [join $args]
        }
      }
    }
  }
}
proc textflood_chk {nick chan} {
  global channel_textflood
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] $chan]} {
    if {[string first textflood [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![isop $nick $chan] && ![isvoc $nick $chan]} {
        if {![info exists channel_textflood([string tolower $nick])]} {
          set channel_textflood([string tolower $nick]) 1
        } {
          incr channel_textflood([string tolower $nick])
          if {$channel_textflood([string tolower $nick]) >= [get_cookie Channel(TextFloodAmmt)]} {/raw kick $chan $nick :\002Text Flood\002 ; break}
        }
      }
    }
  }
}
proc actionflood_chk {nick chan} {
  global channel_actionflood
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] $chan]} {
    if {[string first actionflood [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![isop $nick $chan] && ![isvoc $nick $chan]} {
        if {![info exists channel_actionflood([string tolower $nick])]} {
          set channel_actionflood([string tolower $nick]) 1
        } {
          incr channel_actionflood([string tolower $nick])
          if {$channel_actionflood([string tolower $nick]) >= [get_cookie Channel(ActionFloodAmmt)]} {
            if {[lsearch -glob [string tolower [get_cookie Channel(Controlled)]] [string tolower $chan]] != -1} {/raw kick $chan $nick :\002Action Flood\002 ; break}
          }
        }
      }
    }
  }
}
proc nickflood_chk {nick newnick chan} {
  global channel_nickflood
  set id [chanid [lindex [args] 0]]
  if {$id != -1 && [isop [my_nick] $chan]} {
    if {[string first nickflood [get_cookie ChannelSettings([lindex [get_cookie Channel(Channels)] $id])]] != -1} {
      if {![isop $nick $chan] && ![isvoc $nick $chan]} {
        if {![info exists channel_nickflood([string tolower $nick])]} {
          set channel_nickflood([string tolower $newnick]) 1
        } {
          set channel_nickflood([string tolower $newnick]) [expr $channel_nickflood([string tolower $nick]) + 1]
          unset channel_nickflood([string tolower $nick])
          if {$channel_nickflood([string tolower $newnick]) >= [get_cookie Channel(NickFloodAmmt)]} {
            if {[lsearch -glob [string tolower [get_cookie Channel(Controlled)]] [string tolower $chan]] != -1} {/raw kick $chan $newnick :\002Nick Flood\002 ; break}
          }
        }
      }
    }
  }
}
proc antiidle {} {
  global timers
  set cmd [get_cookie Toggle(AntiIdle)]
  if {$cmd == ""} {
    set_cookie Toggle(AntiIdle) 0
    set cmd "on"
  }
  switch $cmd {
    "on" {
      set_cookie Toggle(AntiIdle) 1
      display "[color highlight][get_cookie Char]Anti-Idle Enabled..."
      if {[lindex [args] 1] == ""} {set mode [get_cookie AntiIdle(Mode)]} {set mode [lindex [args] 1]}
      switch [string tolower $mode] {
        "private" {/timer 2 antiidle_1 ; /timer 5 antiidle_2 ; set_cookie AntiIdle(Mode) "Private"}
        "public" {/timer 1 antiidle_3 ; set_cookie AntiIdle(Mode) "Public"}
        "all" {/timer 2 antiidle_1 ; /timer 5 antiidle_2 ; /timer 1 antiidle_3 ; set_cookie AntiIdle(Mode) "All"}
        default {/timer 2 antiidle_1 ; /timer 5 antiidle_2 ; /timer 1 antiidle_3}
      }
    }
    "off" {
      set_cookie Toggle(AntiIdle) 0
      set names [array names timers]
      if {[string first antiidle* $names] != -1} {/killtimer antiidle*}
    }
  }
}
proc addsplit {args} {
  set splits [get_cookie Split([lindex [server] 0])]
  if {![llength $splits]} {
    set_cookie Split([lindex [server] 0]) $args
  } {
    lappend splits $args
    set_cookie Split([lindex [server] 0]) $args
  }
}
proc remsplit {args} {
  set splits [get_cookie Split([lindex [server] 0])]
  if {[string first $args $splits] != -1} {
    set splits [lreplace $splits [lsearch $splits $args] [lsearch $splits $args]]
    set_cookie Split([lindex [server] 0]) $splits
  }
}
proc ignore {args} {
  global addresslist
  if {[string first - [lindex $args 0]] != -1} {
    set ignoretype [lindex $args 0]
    set ignorenick [lindex $args 1]
    set it [lindex $args 2]
    if {$it == ""} {set it 3}
    if {[string first u $ignoretype] != -1} {
      set time [string trimleft [lindex $args 0] "-apcqu"]
      after [expr 1000 * $time] /ignore -r $ignorenick
    }
    if {[string first i $ignoretype] != -1} {set itype "Invite"}
    if {[string first n $ignoretype] != -1} {set itype "Notice"}
    if {[string first p $ignoretype] != -1} {set itype "Public"}
    if {[string first q $ignoretype] != -1} {set itype "Query"}
    if {[string first c $ignoretype] != -1} {set itype "CTCP"}
    if {[string first a $ignoretype] != -1} {set itype "All"}
    if {[string first r $ignoretype] != -1} {
      if {[string first @ [lindex $args 1]] != -1} {
        set_cookie Ignore 1
        foreach itype [get_cookie Ignore(Types)] {
          if {[get_cookie Ignore($itype)] != ""} {
            set id [lsearch -exact [get_cookie Ignore($itype)] [lindex $args 1]]
            if {$id != -1} {
              set ignore($itype-[lindex [server] 0]) [lreplace [get_cookie Ignore($itype)] $id $id]
              set_cookie Ignore($itype) $ignore($itype-[lindex [server] 0])
            }
          }
        }
      }
    }
    if {[get_cookie Ignore] == ""} {
      if {[string first @ [lindex $args 1]] == -1} {
        if {![info exists addresslist([string tolower $ignorenick])]} {
          set_cookie VariableEvent(Ignore) 1
          /who $ignorenick
          on 352 {
            if {[get_cookie VariableEvent(Ignore)] == 1} {
              display "[get_cookie Char]Getting address"
              addresslist [lindex [args] 5] [lindex [args] 2] [lindex [args] 3]
              set imask [getmask [lindex [args] 5]![lindex [args] 2]@[lindex [args] 3] $it]
              set ignore($itype-[lindex [server] 0]) [get_cookie Ignore($itype)]
              if {[lsearch $ignore($itype-[lindex [server] 0]) $imask] == -1} {
                lappend ignore($itype-[lindex [server] 0]) $imask
                set_cookie Ignore($itype) $ignore($itype-[lindex [server] 0])
              }
            }
            complete
          }
          on 315 {set_cookie VariableEvent(Ignore) "" ; complete}
        } {
          set imask [getmask $addresslist([string tolower $ignorenick]) $it]
          set ignore($itype-[lindex [server] 0]) [get_cookie Ignore($itype)]
          if {[lsearch $ignore($itype-[lindex [server] 0]) $imask] == -1} {
            lappend ignore($itype-[lindex [server] 0]) $imask
            set_cookie Ignore($itype) $ignore(All-[lindex [server] 0])
          }
        }
      } elseif {[lindex $args 1] == "*!*@*"} {
        set imask [lindex $args 1]
        set ignore($itype-[lindex [server] 0]) [get_cookie Ignore($itype)]
        lappend ignore($itype-[lindex [server] 0]) [lindex $args 1]
        set_cookie Ignore($itype) $ignore($itype-[lindex [server] 0])
      } {
        set imask [lindex $args 1]
        set ignore($itype-[lindex [server] 0]) [get_cookie Ignore($itype)]
        if {[lsearch $ignore($itype-[lindex [server] 0]) $imask] == -1} {
          lappend ignore($itype-[lindex [server] 0]) $imask
          set_cookie Ignore($itype) $ignore(All-[lindex [server] 0])
        }
      }
    }
  } {
    set ignorenick [lindex $args 0]
    set it [lindex $args 1]
    if {$it == ""} {set it 3}
    if {[string first @ [lindex $args 0]] == -1} {
      if {![info exists addresslist([string tolower $ignorenick])]} {
        set_cookie VariableEvent(Ignore) 1
        /who $ignorenick
        on 352 {
          if {[get_cookie VariableEvent(Ignore)] == 1} {
            display "[get_cookie Char]Getting address"
            addresslist [lindex [args] 5] [lindex [args] 2] [lindex [args] 3]
            set imask [getmask [lindex [args] 5]![lindex [args] 2]@[lindex [args] 3] $it]
            set ignore(All-[lindex [server] 0]) [get_cookie Ignore(All)]
            set id [lsearch $ignore(All-[lindex [server] 0]) $imask]
            if {$id == -1} {
              lappend ignore(All-[lindex [server] 0]) $imask
              set_cookie Ignore(All) $ignore(All-[lindex [server] 0])
            } {
              set ignore(All-[lindex [server] 0]) [lreplace $ignore(All-[lindex [server] 0]) $id $id]
              lappend ignore(All-[lindex [server] 0]) $imask
            }
          }
          complete
        }
        on 315 {set_cookie VariableEvent(Ignore) "" ; complete}
      } {
        set imask [getmask $addresslist([string tolower $ignorenick]) $it]
        set ignore(All-[lindex [server] 0]) [get_cookie Ignore(All)]
        set id [lsearch $ignore(All-[lindex [server] 0]) $imask]
        if {$id == -1} {
          lappend ignore(All-[lindex [server] 0]) $imask
          set_cookie Ignore(All) $ignore(All-[lindex [server] 0])
        } {
          set ignore(All-[lindex [server] 0]) [lreplace $ignore(All-[lindex [server] 0]) $id $id]
          lappend ignore(All-[lindex [server] 0]) $imask
        }
      }
    } elseif {[lindex $args 0] == "*!*@*"} {
      set imask [lindex $args 0]
      set ignore(All-[lindex [server] 0]) [get_cookie Ignore(All)]
      lappend ignore(All-[lindex [server] 0]) [lindex $args 1]
      set_cookie Ignore(All) $ignore(All-[lindex [server] 0])
    } {
      set imask [lindex $args 0]
      set ignore(All-[lindex [server] 0]) [get_cookie Ignore(All)]
      set id [lsearch $ignore(All-[lindex [server] 0]) $imask]
      if {$id == -1} {
        lappend ignore(All-[lindex [server] 0]) $imask
        set_cookie Ignore(All) $ignore(All-[lindex [server] 0])
      } {
        set ignore(All-[lindex [server] 0]) [lreplace $ignore(All-[lindex [server] 0]) $id $id]
        lappend ignore(All-[lindex [server] 0]) $imask
      }
    }
  }
  set_cookie Ignore ""
}
proc ban {args} {
  global addresslist
  set banchan [lindex $args 0]
  set bantype [lindex $args 1]
  set bannick [nc [lindex $args 2]]
  set bt [lindex $args 3]
  if {![llength $bt]} {set bt 3}
  if {[string first u $bantype] != -1} {
    set time [string trimleft [lindex $args 0] -u]
  }
  if {[string first @ [lindex $args 1]] == -1} {
    if {![info exists addresslist([string tolower $bannick])] && [llength $bannick]} {
      set_cookie VariableEvent(Ban) 1
      /who $bannick
      on 352 {
        if {[get_cookie VariableEvent(Ban)] == 1} {
          display "[get_cookie Char]Getting address"
          addresslist [lindex [args] 5] [lindex [args] 2] [lindex [args] 3]
          set bmask [getmask [lindex [args] 5]![lindex [args] 2]@[lindex [args] 3] $bt]
          /raw mode $banchan -o+b $bannick $bmask
          after [expr $time * 1000] /raw mode $banchan -b $bmask
        }
        complete
      }
      on 315 {set_cookie VariableEvent(Ban) "" ; complete}
    } {
      if {[info exists addresslist([string tolower [lindex $args 1]])]} {
        set bmask [getmask $addresslist([string tolower [lindex $args 1]]) $bt]
      } {set bmask [lindex $args 1]}
      /raw mode $banchan +b $bmask
      after [expr $time * 1000] /raw mode $banchan -b $bmask
    }
  } {
    set bmask [lindex $args 1]
    /raw mode $banchan +b $bmask
    after [expr $time * 1000] /raw mode $banchan -b $bmask
  }
}
proc online {} {
  global IRCserver
  if {[connected]} {set_cookie Connection($IRCserver) 1}
  if {[get_cookie Connection($IRCserver)] == 1 && ![connected]} {/server [irc_server]}
  /utimer 60 online
}
proc irc_server {} {global IRCserver ; return $IRCserver}
proc getmask {addr type} {
  set nick [lindex [split $addr !] 0]
  set host [lindex [split $addr @] 1]
  set uhost [lindex [split $addr !] 1]
  set user [lindex [split $uhost @] 0]
  if {[string first ! $addr] == -1} {set type 10}
  if {[string length $user] > 8} {set user [string range $user [expr [string length $user] - 8] end]}
  if {[string first ~ $user] != -1 || [string first * $user] != -1} {set user *[string range $user 1 end]} {set user *$user}
  if {[string trim $host 1234567890.] == ""} {set host [join [lrange [split $host .] 0 2] .].*} {
    if {[llength [split $host .]] > 4} {
      set host *.[join [lrange [split $host .] [expr [llength [split $host .]] - 3] end] .]
    } elseif {[llength [split $host .]] >= 3} {
      set host *.[join [lrange [split $host .] 1 end] .]
    }
  }
  switch [lindex $type 0] {
    "0" {set mask *!$uhost}
    "1" {set mask *!$user@[lindex [split $addr @] 1]}
    "2" {set mask *!*@[lindex [split $addr @] 1]}
    "3" {set mask *!$user@$host}
    "4" {set mask *!*@$host}
    "5" {set mask $addr}
    "6" {set mask $nick!$user@[lindex [split $addr @] 1]}
    "7" {set mask $nick!*@[lindex [split $addr @] 1]}
    "8" {set mask $nick!$user@$host}
    "9" {set mask $nick!*@$host}
    default {set mask $addr!*@*}
  }
  return $mask
}
proc openseen {} {
  global lastseen lastseen_length
  if {[file size [gdx][get_cookie DatFile(Lastseen)]] != 0} {
    set id [open [gdx][get_cookie DatFile(Lastseen)] r]
    addsocket $id
    while {![eof $id]} {
      set line [gets $id]
      if {$line != ""} {
        set lastseen([lindex $line 0]) "[list [lrange $line 1 end]]"
      }
    }
    close $id
    killsocket $id
    set lastseen_length [llength [array names lastseen]]
    set_cookie Lastseen(Length) [llength [array names lastseen]]
  }
}
proc lastseen {nick addr date type chan args} {
  global lastseen lastseen_length
  if {[get_cookie Toggle(Lastseen)]} {
    set lastseen([string tolower $nick]) "{$addr $date $type $chan $args}"
    set lastseen_length [llength [array names lastseen]]
    if {$lastseen_length >= [expr [get_cookie Lastseen(Length)] + 10]} {saveseen}
  }
}
proc saveseen {} {
  global lastseen lastseen_length
  if {[info exists lastseen]} {
    set id [open [gdx][get_cookie DatFile(Lastseen)] w]
    addsocket $id
    foreach nick [lsort [array names lastseen]] {
      if {[lindex $lastseen($nick) 1] <= [expr [clock seconds] - [get_cookie Lastseen(Modifier)]]} {
        puts -nonewline $id "$nick [lindex $lastseen($nick) 0]\n"
      }
    }
    set_cookie Lastseen(Length) [llength [array names lastseen]]
    close $id
    killsocket $id
  }
}
proc get_server {args} {
  global serverlist
  set server [lindex $args 1]
  if {![info exists serverlist]} {set serverlist ""}
  if {[lsearch [string tolower $serverlist] [string tolower $server]] == -1} {
    lappend serverlist "$server"
  }
}
proc write_serverlist {} {
  global serverlist
  set id [open [gdx][get_cookie DatFile(Servers)] w]
  addsocket $id
  puts -nonewline $id [join $serverlist \n]
  close $id
  killsocket $id
}
proc getnotify {} {
  global notify
  if {[info exists notify]} {unset notify}
  if {[file exists [gdx][get_cookie DatFile(Notify)]]} {
    set id [open [gdx][get_cookie DatFile(Notify)] r]
    addsocket $id
    while {![eof $id]} {
      set entry [gets $id]
      if {[string length $entry] > 0} {
        set notify([lindex $entry 0]) [list {} {} {}]
        set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 0 0 [lindex $entry 1]]
        set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 1 1 [lindex $entry 2]]
        set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 2 2 [lrange $entry 3 end]]
      }
    }
    close $id
    killsocket $id
  }
  set_cookie Notify(CurrentList) [join [array names notify]]
}
proc opennotify {} {
  global notify
  if {[info exists notify]} {unset notify}
  set id [open [gdx][get_cookie DatFile(Notify)] r]
  addsocket $id
  while {![eof $id]} {
    set entry [gets $id]
    if {[string length $entry] > 0} {
      set notify([lindex $entry 0]) [list {} {} {}]
      set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 0 0 [lindex $entry 1]]
      set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 1 1 [lindex $entry 2]]
      set notify([lindex $entry 0]) [lreplace $notify([lindex $entry 0]) 2 2 [lrange $entry 3 end]]
    }
  }
  close $id
  killsocket $id
  set_cookie Notify(CurrentList) [join [array names notify]]
  set_cookie Notify(FileMtime) [file mtime [gdx][get_cookie DatFile(Notify)]]
  return [join [array names notify]]
}
proc chk4spec {string} {
  regsub -all {\\} $string {\\\\} string
  regsub -all {\{} $string {\{} string
  regsub -all {\[} $string {\[} string
  regsub -all {\"} $string {\"} string
  return  $string
}
proc chk4leet {string} {
  regsub -all {a} $string {4} string
  regsub -all {A} $string {4} string
  regsub -all {e} $string {3} string
  regsub -all {E} $string {3} string
  regsub -all {i} $string {1} string
  regsub -all {I} $string {1} string
  regsub -all {l} $string {|} string
  regsub -all {L} $string {|} string
  regsub -all {o} $string {0} string
  regsub -all {O} $string {0} string
  regsub -all {t} $string {7} string
  regsub -all {T} $string {7} string
  regsub -all {w} $string {\\\\'} string
  regsub -all {W} $string {\\\\'} string
  regsub -all {f} $string {ph} string
  regsub -all {F} $string {pH} string
  return  $string
}
proc longip {ip} {
  global tcl_precision
  set tcl_precision 17
  set result 0
  regexp {([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)} $ip s b3 b2 b1 b0
  if {![string compare $ip $s]} {
    set total 0
    set total [expr $total + double($b3) * pow(256,3)]
    set total [expr $total + double($b2) * pow(256,2)]
    set total [expr $total + double($b1) * pow(256,1)]
    set total [expr $total + double($b0) * pow(256,0)]
    set result [format "%10.0f" $total]
  }
  return $result
}
proc stricmp {s1 s2} {return [string compare [string tolower $s1] [string tolower $s2]]}
proc cycle_up {} {
  set x [get_cookie Status]
  if {$x == 4} {set x -1}
  set_cookie Status [incr x]
  status_page [get_cookie Status]
}
proc cycle_dn {} {
  set x [get_cookie Status]
  if {$x == 0} {set x 5}
  set_cookie Status [incr x -1]
  status_page [get_cookie Status]
}
proc add_query {nick} {
  if {[get_cookie Queries([lindex [server] 0])] != ""} {
    set queries [chk4spec $nick]
    foreach name [get_cookie Queries([lindex [server] 0])] {
      if {[lsearch [string tolower $queries] [string tolower $name]] == -1} {lappend queries [chk4spec $name]}
    }
    set_cookie Queries([lindex [server] 0]) [join $queries]
  } {
    set_cookie Queries([lindex [server] 0]) [join $nick]
  }
}
proc get_query {} {
  set nick [lindex [get_cookie Queries([lindex [server] 0])] 0]
  if {$nick == ""} {
    input set_text "/msg "
    input set_sel_start 5
  } {
    input set_text "/msg $nick "
    input set_sel_start [expr [string length $nick] + 6]
  }
  set queries [join [lrange [get_cookie Queries([lindex [server] 0])] 0 end]]
  if {[lsearch [string tolower [chk4spec $queries]] [string tolower [chk4spec $nick]]] == -1} {lappend queries [chk4spec $nick]}
  set_cookie Queries([lindex [server] 0]) "[lrange $queries 1 7] [chk4spec $nick]"
  complete
}
proc add_dcc {nick} {
  if {[get_cookie DCCS([lindex [server] 0])] != ""} {
    set dccs [chk4spec $nick]
    foreach name [get_cookie DCCS([lindex [server] 0])] {
      if {[lsearch [string tolower $dccs] [string tolower $name]] == -1} {lappend dccs [chk4spec $name]}
    }
    set_cookie DCCS([lindex [server] 0]) [join $dccs]
  } {
    set_cookie DCCS([lindex [server] 0]) [join $nick]
  }
}
proc get_dcc {} {
  set nick [lindex [get_cookie DCCS([lindex [server] 0])] 0]
  if {$nick != ""} {
    input set_text "/msg =$nick "
    input set_sel_start [expr [string length $nick] + 7]
  } {
    if {[chats] == ""} {
      input set_text "/msg "
      input set_sel_start 5
    } {
      input set_text "/msg =[lindex [chats] 0] "
      input set_sel_start [expr [string length [lindex [chats] 0]] + 7]
    }
  }
  set dccs [join [lrange [get_cookie DCCS([lindex [server] 0])] 0 end]]
  if {[lsearch [string tolower [chk4spec $dccs]] [string tolower [chk4spec $nick]]] == -1} {lappend dccs [chk4spec $nick]}
  set_cookie DCCS([lindex [server] 0]) "[lrange $dccs 1 4] [chk4spec $nick]"
  complete
}

### start of XDCC routines ###
proc filesizecalc {packet} {
  if {[isnum $packet]} {
    if {[string length $packet] > 6} {
      set size [expr $packet / 10 / 1024 / 100.0]Mb
    } elseif {[string length $packet] <= 6} {
      set size [expr $packet * 100 / 1024 / 100]Kb
    }
    return $size
  } elseif {[get_cookie XDCC($packet)Packet] != ""} {
    if {[string length [expr [get_cookie XDCC($packet)Size]]] > 6} {
      set size [expr [get_cookie XDCC($packet)Size] / 10 / 1024 / 100.0]Mb
    } elseif {[string length [expr [get_cookie XDCC($packet)Size]]] <= 6} {
      set size [expr [get_cookie XDCC($packet)Size] * 100 / 1024 / 100]Kb
    }
    return $size
  }
  return 0
}
proc xdcc {args} {
  global version
  set XDCCdest [lindex $args 1]
  if {![file isdirectory [gdd]]} {file mkdir [gdd]}
  switch [string tolower [lindex $args 0]] {
    "offer" {
      display "[get_cookie Char]\[\002$version\002\] XDCC Packet Library Offered to [color nick]$XDCCdest"
      /raw privmsg $XDCCdest :[string range "(\[\002$version\002\] \002(\002[expr [get_cookie XDCC(Sockets)] - [dcc_count]]/6\002)\002 XDCC PACKET LIBRARY OFFERED BY [my_nick] \[\002$version\002\])" 0 end]
      /raw privmsg $XDCCdest :[string range "(Type \002/CTCP [my_nick] XDCC SEND #N\002 To Get Packet #N.)" 0 end]
      for {set xno 0} {$xno < 10} {incr xno} {
        if {[get_cookie XDCC(#[expr $xno + 1])Packet] != ""} {
          set size [filesizecalc #[expr $xno + 1]]
          set gets [get_cookie XDCC(#[expr $xno + 1])Gets]
          /raw privmsg $XDCCdest :[string range " (\002 [expr $xno + 1] \002) [get_cookie XDCC(#[expr $xno + 1])Packet] (\002$size\002) [get_cookie XDCC(#[expr $xno + 1])Desc] (\002$gets x\002)" 0 end]
        } {break}
      }
    }
    "send" {
      set packet "#[string trim [lindex $args 2] #]"
      if {![llength [get_cookie XDCC($packet)Packet]]} {set replyline "No Such XDCC Packet"
      } elseif {![llength [lindex $args 1]]} {set replyline "No packet destination"}
      if {[info exists replyline]} {/raw notice [lindex $args 1] :$replyline
      } {
        logevent xdcc "Processing XDCC Send packet $packet ([get_cookie XDCC($packet)Packet]) for [lindex $args 1]"
        /raw notice [lindex $args 1] :\001Preparing request for packet #[string trim [lindex $args 2] #] ([get_cookie XDCC($packet)Packet])\001
        XDCCqueue send $XDCCdest $packet
      }
    }
  }
}
proc XDCCqueue {args} {
  global track XDCCqueue
  if {[llength [join $args]] > 1} {
    set command [lindex $args 0]
    set XDCCdest [lindex $args 1]
    set packet [lindex $args 2]
    /raw notice $XDCCdest :Processing your request, $XDCCdest...
    if {$packet != ""} {
      if {![get_cookie XDCC(Offering)]} {
        /raw notice $XDCCdest :Sorry, XDCC Packet Library Disabled.
        return 0
      } elseif {[expr [get_cookie XDCC(Sockets)] - [dcc_count]] <= 0} {
        /raw notice $XDCCdest :No Available XDCC Sockets
        /raw notice $XDCCdest :Queuing your XDCC request...
        if {[array exists XDCCqueue]} { 
          set XDCCqueue([expr [lindex [array names XDCCqueue] end] +1]) "send $XDCCdest $packet"
        } else {
          set XDCCqueue(1) "send $XDCCdest $packet"
        }
        return 0
      } {
        set_cookie XDCC($packet)Gets [expr [get_cookie XDCC($packet)Gets] + 1]
        logevent xdcc "Sending $XDCCdest packet $packet [gdd][get_cookie XDCC($packet)Packet]"
        /dcc send $XDCCdest [gdd][get_cookie XDCC($packet)Packet]
        return 0
      }
    }
  } {
    set temp $XDCCqueue([lindex [array names XDCCqueue] 0])
    unset XDCCqueue([lindex [array names XDCCqueue] 0])
    set command [lindex $temp 0]
    set XDCCdest [lindex $temp 1]
    set packet [lindex $temp 2]
    /raw notice $XDCCdest :Processing your queued request, $XDCCdest...
    if {$packet != ""} {
      if {![get_cookie XDCC(Offering)]} {
        /raw notice $XDCCdest :Sorry, XDCC Packet Library Disabled.
        return 0
      } elseif {[get_cookie XDCC(Track)]} {
        /raw notice $XDCCdest :Sorry, a command is in progress.
        /raw notice $XDCCdest :Re-queuing your request...
        if {[array exists XDCCqueue]} { 
          set XDCCqueue([expr [lindex [array names XDCCqueue] end] +1]) "send $XDCCdest $packet"
        } else {
          set XDCCqueue(1) "send $XDCCdest $packet"
        }
        return 0
      } elseif {![get_cookie XDCC(Track)]} {
        set_cookie XDCC(Track) 1
        set_cookie XDCC($packet)Gets [expr [get_cookie XDCC($packet)Gets] + 1]
        logevent xdcc "Sending $XDCCdest packet $packet [gdd][get_cookie XDCC($packet)Packet]"
        /dcc send $XDCCdest [gdd][get_cookie XDCC($packet)Packet]
        return 0
      }
    }
  }
  /raw notice $XDCCdest :Error, Not a valid XDCC choice.
}

### start of address/userlist routines ###
proc addresslist {nick user host} {
  global addresslist
  set addresslist([string tolower $nick]) "$nick!$user@$host"
  return $addresslist([string tolower $nick])
}
proc update_ul {chan} {set_cookie Update(IAL-[lindex [server] 0]) 1 ; /who $chan}
proc create_ul {} {
  global addresslist
  if {[connected]} {
    if {[get_cookie Toggle(IAL-[lindex [server] 0])] == 1} {
      set_cookie Update(IAL-[lindex [server] 0]) 1
      set_cookie Toggle(IAL-[lindex [server] 0]) 0
      if {[channels] != ""} {
        display "[color highlight][get_cookie Char]Updating Internal Address List..."
        foreach chan [channels] {/raw who $chan}
      }
    }
  }
}

### start of userlist routines (beta) ###
proc adduser {nick addr} {
  global hostmask userlist
  set id [lsearch [chk4spec [join [string tolower [array names userlist]]]] [string tolower [chk4spec $nick]]]
  if {$id == -1} {
    for {set au 0} {$au < [llength [array names hostmask]]} {incr au} {
      for {set um 0} {$um < [llength [gethosts [lindex [array names hostmask] $au]]]} {incr um} {
        if {[string match [lindex [gethosts [lindex [array names hostmask] $au]] $um] $addr] == 1} {return [lindex [array names hostmask] $au]}
      }
    }
    set userlist($nick) "{} {} {} {} {} {}"
    set hostmask($nick) [getmask $addr 3]
    return 1
  } {return [lindex [array names hostmask] $id]}
  return 0
}
proc remuser {nick} {
  global userlist channel hostmask
  set id [lsearch [chk4spec [join [string tolower [array names userlist]]]] [string tolower [chk4spec $nick]]]
  if {$id != -1} {
    set nick [lindex [join [chk4spec [array names userlist]]] $id]
    unset userlist($nick)
    unset hostmask($nick)
    return 1
  }
  return 0
}
proc getuserfile {} {
  global userlist hostmask channel
  set id [open [gdx][get_cookie DatFile(UserList)] r]
  addsocket $id
  set oldhandle ""
  set line [string trim [gets $id]]
  while {![eof $id]} {
    set line [string trim [gets $id]]
    if {([string index $line 0] != "#") && ([string length $line] > 0)} {
      scan $line "%s" handle
      if {$handle == "--HOSTS"} {
        # hostmasks
        set hmList [lindex $line 1]
        lappend hostmask($oldhandle) $hmList
      } elseif {$handle == "--PASS"} {
        # password
        set pass [lindex $line 1]
        set userlist($oldhandle) [lreplace $userlist($oldhandle) 0 0 $pass]
      } elseif {$handle == "--FLAGS"} {
        # flags
        set flags [lindex $line 1]
        set userlist($oldhandle) [lreplace $userlist($oldhandle) 1 1 $flags]
      } elseif {$handle == "--CHAN"} {
        # channels
        set chList [lrange $line 1 end]
        lappend channel($oldhandle) [lrange $chList 0 end]
      } else {
        # begin of new user
        scan $line "%s" handle
        set userlist($handle) [list {} {} {} {} {} {}]
        set hostmask($handle) ""
        set channel($handle) ""
        set oldhandle $handle
      }
    }
  }
  close $id
  killsocket $id
}
proc saveuserfile {} {
  global fullversion userlist hostmask channel
  if {[file exists [gdx][get_cookie DatFile(UserList)]]} {
    display "[get_cookie Char]Writing user file ..."
    file rename -force [gdx][get_cookie DatFile(UserList)] [gdx][get_cookie DatFile(UserList)]~bak
    set id [open [gdx][get_cookie DatFile(UserList)] w]
    addsocket $id
    puts $id "# $fullversion userfile"
    foreach i [array names userlist] {
      set hmask "none"
      set hmloop 0 ; set chloop 0
      puts $id $i
      if {[lindex $userlist($i) 0] != ""} {puts $id "--PASS [lindex $userlist($i) 0]"}
      if {[lindex $userlist($i) 1] != ""} {puts $id "--FLAGS [lindex $userlist($i) 1]"}
      if {[info exists channel($i)]} {
        for {} {$chloop < [llength $channel($i)]} {incr chloop} {
          puts $id "--CHAN [lindex $channel($i) $chloop]"
        }
      }
      for {} {$hmloop < [llength $hostmask($i)]} {incr hmloop} {
        puts $id "--HOSTS [lindex $hostmask($i) $hmloop]"
      }
    }
    close $id
    killsocket $id
  }
}
proc matchattr {args} {
  global addresslist userlist channel hostmask
  set id [lsearch [string tolower [array names userlist]] [string tolower [lindex $args 0]]]
  if {[lindex $args 2] == ""} {
    if {$id != -1} {
      set nick [lindex [array names userlist] $id]
      if {[string first [lindex $args 1] [lindex $userlist($nick) 1]] != -1} {return 1}
    } {
      foreach n [join [string tolower [chk4spec [join [array names hostmask]]]]] {
        if {[info exists addresslist([string tolower $nick])]} {
          if {[isin [getmask $addresslist([string tolower $nick]) 3] [gethosts $n]]} {
            if {[string first [lindex $args 1] [lindex $userlist($n) 1]] != -1} {return 1}
          }
        }
      }
    }
  } {
    if {$id != -1} {
      set nick [lindex [array names channel] $id]
      if {[info exists channel($nick)]} {
        for {set mccloop 0} {$mccloop < [llength $channel($nick)]} {incr mccloop} {
          set chan [lindex [lindex $channel($nick) $mccloop] 0]
          if {[string compare [string tolower $chan] [string tolower [lindex $args 2]]] == 0} {
            if {[string first [lindex $args 1] [lindex [lindex $channel($nick) $mccloop] 1]] != -1} {return 1}
          }
        }
      }
    } {
      foreach n [join [chk4spec [join [array names hostmask]]]] {
        if {[info exists addresslist([string tolower [lindex $args 0]])]} {
          set hm [gethosts $n]
          if {[isin [getmask $addresslist([string tolower [lindex $args 0]]) 3] [gethosts $n]]} {
            if {[info exists channel($n)]} {
              for {set mccloop 0} {$mccloop < [llength $channel($n)]} {incr mccloop} {
                set chan [lindex [lindex $channel($n) $mccloop] 0]
                if {[string compare [string tolower $chan] [string tolower [lindex $args 2]]] == 0} {
                  if {[string first [lindex $args 1] [lindex [lindex $channel($n) $mccloop] 1]] != -1} {return 1}
                }
              }
            }
          }
        }
      }
    }
  }
  return 0
}
proc nick2hand {args} {
  global hostmask
  foreach user [array names hostmask] {
    for {set u 0} {$u < [llength [gethosts $user]]} {incr u} {
      if {[string match [lindex [gethosts $user] $u] [getchanhost [lindex $args 0] [lindex $args 1]]] == 1} {return $user}
    }
  }
  return 0
}
proc getchanhost {args} {
  global addresslist
  if {[ison [lindex $args 0] [lindex $args 1]]} {
    if {![info exists addresslist([string tolower [lindex $args 0]])]} {
      set_cookie VariableEvent(Hosts) 1
      /who [lindex $args 0]
      on 352 {
        if {[get_cookie VariableEvent(Hosts)] == 1} {
          display "[get_cookie Char]Getting address"
          addresslist [lindex [args] 5] [lindex [args] 2] [lindex [args] 3]
          return [lindex [args] 5]![lindex [args] 2]@[lindex [args] 3]
        }
        complete
      }
      on 315 {set_cookie VariableEvent(Hosts) "" ; complete}
    } {return $addresslist([string tolower [lindex $args 0]])}
  }
  return 0
}
proc gethosts {args} {
  global hostmask
  if {[info exists hostmask($args)]} {return $hostmask($args)} {return -1}
}
proc finduser {args} {
  global userlist
  foreach u [array names userlist] {
    if {[string first $args $userlist($u)] != -1} {return $u}
  }
  return 0
}
