alias timers {/timer ; complete}
alias timer {
  global timers
  if {[lindex [args] 0] == ""} {
    set names [array names timers] ; set list ""
    foreach no [lsort -increasing $names] {
      set t $timers($no) ; set elapsed [elapsed [lindex $t 0]]
      if {$elapsed < 0} {unset timers($no)} {append list "\{[expr $elapsed + 1] [lrange $t 2 end]\} "}
    }
    if {$list == ""} {display "[color highlight][get_cookie Char]No timers active."} {display "[get_cookie Char]$list" ; complete}
  } {
    set var [lindex [args] 0] ; set proc [lrange [args] 1 end]
    set names [array names timers] ; set clock min.[expr $var * 60 + [clock seconds]]
    foreach no $names {
      set t $timers($no)
      if {[string match [lrange $proc 0 end] [lindex $t 2]]} {unset timers($no)}
    }
    set id [after [expr $var * 60 * 1000] [lrange $proc 0 end]]
    set timers($clock) "$clock $var [join $proc] $id"
  }
  complete
}
alias killtimer {
  global timers
  set names [array names timers] ; set cnt 0
  foreach no $names {
    set t $timers($no)
    if {[lsearch $t *[args]] != -1} {incr cnt ; display "[color highlight][get_cookie Char]Timer [lindex $timers($no) end] halted" ; after cancel [lindex $timers($no) end] ; unset timers($no)}
  }
  if {$cnt == 0} {display "[color highlight][get_cookie Char]Timer is not active."}
  complete
}

alias utimers {/utimer ; complete}
alias utimer {
  global utimers
  if {[lindex [args] 0] == ""} {
    set names [array names utimers] ; set list ""
    foreach no [lsort -increasing $names] {
      set t $utimers($no) ; set elapsed [elapsed [lindex $t 0]]
      if {$elapsed < 0} {unset utimers($no)} {append list "\{[expr $elapsed + 1] [lrange $t 2 end]\} "}
    }
    if {$list == ""} {display "[color highlight][get_cookie Char]No utimers active."} {display "[get_cookie Char]$list" ; complete}
  } {
    set var [lindex [args] 0] ; set proc [lrange [args] 1 end]
    set names [array names utimers] ; set clock sec.[expr $var + [clock seconds]]
    foreach no $names {
      set t $utimers($no)
      if {[string match [lrange $proc 0 end] [lindex $t 2]]} {unset utimers($no)}
    }
    set id [after [expr $var * 1000] [join [lrange $proc 0 end]]]
    set utimers($clock) "$clock $var [join $proc] $id"
  }
  complete
}
alias killutimer {
  global utimers
  set names [array names utimers] ; set cnt 0
  foreach no $names {
    set t $utimers($no)
    if {[lsearch $t *[args]] != -1} {incr cnt ; display "[color highlight][get_cookie Char]Timer [lindex $utimers($no) end] halted" ; after cancel [lindex $utimers($no) end] ; unset utimers($no)}
  }
  if {$cnt == 0} {display "[color highlight][get_cookie Char]Timer is not active."}
  complete
}

proc elapsed {ticks} {
  set current [clock seconds]
  set type [split $ticks .]
  if {[lindex $type 0] == "min"} {set elapsed [string trimright [expr [expr [lindex $type 1] - $current] / 60] .]}
  if {[lindex $type 0] == "sec"} {set elapsed [expr [lindex $type 1] - $current]}
  return $elapsed 
}

alias cnttimers {
  global timers
  set n 0 ; set t [array names timers]
  foreach no $t {incr n}
  display "[get_cookie Char]There are $n timers running."
  complete
}

### Idleing Procedures
proc antiidle_1 {} {if {[connected]} {/ctcp [my_nick] ping} ; /timer 2 antiidle_1}
proc antiidle_2 {} {if {[connected]} {/whois [my_nick]} ; /timer 5 antiidle_2}
proc antiidle_3 {} {if {[connected]} {/msg #^TeStInG .} ; /timer 100 antiidle_3}
